/* 
 * Evorobot - A software for running evolutionary robotics experiments
 * Copyright (C) 2000 Stefano Nolfi. - Institute of Psychology - CNR - Rome 
 * nolfi@ip.rm.cnr.it - http://gral.ip.rm.cnr.it/nolfi 

 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


/*
 * interface.c
 */

#include "defs.h"

#define APPNAME "Evorobot Secondary"
#define APPNAMEM "Evorobot"

#include <windows.h>
#include <commdlg.h>
#include <winnls.h>

#include "resource.h"
#include "w32graph.h"

#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <conio.h>


HINSTANCE	hinst,hinstm,hinstmp;
HWND		hwnd,hwndm;
WNDCLASS	wc,wcm;
HDC		hdc,hdcm,c_hdc;
MSG		msg,msgm;

DWORD dwThreadId, dwThrdParam = 0; 
HANDLE hThread,mThread; 

PAINTSTRUCT ps,psm; 
RECT		rc;

HMENU mm;

DWORD dwThreadId3, dwThrdParam3 = 0;
HANDLE hThread3;

/****************************************************************************/


#define F_LOAD       11
#define F_EXIT       15

#define P_POPULATION 21
#define P_EVOLUTION  22
#define P_LIFETIME   23
#define P_DISPLAY    24
#define P_ENVIRONMENT 25
#define P_SAVE       26


#define R_EVOLUTION  31
#define R_TEST	     32
#define R_TESTB	     33
#define R_MASTER     34
#define R_SAMPLE     35
#define R_TESTSC     36
#define R_STOP       37

#define D_SAMPLE     41
#define D_FITNESS    42
#define D_IO_MAPS    43
#define D_CLEAR      44



#define H_ABOUT      51

int fs=0;

int nu=50;
int nc=200;
int ng=50;
int wdx=640;
int wdy=580;
int tm=0;

OPENFILENAME  lpofn;
//char lpofn_filter[] = "parameters\0*.cf;\0";
char lpofn_filter[] = "configuration\0*.cf;\0genotype\0*.gen;\0fitness\0*.fit;\0environment\0*.env;\0sample\0*.sam;\0map\0*.map;\0";

LPSTR lpc;

/*
 * The functions of this file
 */
void creamenu();
void enable_menu();
void disable_menu();
void check_par_box2();
int APIENTRY WinMain(HINSTANCE hinstm, HINSTANCE hinstmp, LPSTR lpc,  int cmsh);
LRESULT CALLBACK WindowProc(HWND w,UINT m,WPARAM p1,LPARAM p2);
void ciclomain();
LRESULT CALLBACK WindowProcM(HWND w,UINT m,WPARAM p1,LPARAM p2);
BOOL CALLBACK boxproc2(HWND w,UINT m,WPARAM p1,LPARAM p2);
BOOL CALLBACK boxproc3(HWND w,UINT m,WPARAM p1,LPARAM p2);
BOOL CALLBACK boxproc4(HWND w,UINT m,WPARAM p1,LPARAM p2);
BOOL CALLBACK boxproc5(HWND w,UINT m,WPARAM p1,LPARAM p2);
BOOL CALLBACK boxproc6(HWND w,UINT m,WPARAM p1,LPARAM p2);
BOOL CALLBACK boxprocss(HWND w,UINT m,WPARAM p1,LPARAM p2);
BOOL CALLBACK boxprocsa(HWND w,UINT m,WPARAM p1,LPARAM p2);
BOOL CALLBACK boxprochlp(HWND w,UINT m,WPARAM p1,LPARAM p2);
void creawin();
void chiudewin();
DWORD finestra(LPDWORD p);

int    oldnpopulations;
int    oldbestfathers;
int    oldnkids;
int    oldopp_from_prev;
int    old1cameraunits;
int    old2cameraunits;
int    old1nhiddens;
int    old2nhiddens;
int    old1input_outputs;
int    old2input_outputs;

/* 
 * creazione del menu' (non viene utilizzato l'editor di risorse) 
 */

void
creamenu()
{

   HMENU m1,m2,m3,m4,m5,m6;
   mm=	CreateMenu();

   m1= CreatePopupMenu();
   m2= CreatePopupMenu();
   m3= CreatePopupMenu();
   m4= CreatePopupMenu();
   m5= CreatePopupMenu();
   m6= CreatePopupMenu();

  
   AppendMenu(mm,MF_POPUP|MF_STRING,m1,"&File");
   AppendMenu(mm,MF_POPUP|MF_STRING,m2,"&Parameters");
   AppendMenu(mm,MF_POPUP|MF_STRING,m3,"&Run");
   AppendMenu(mm,MF_POPUP|MF_STRING,m5,"&Display");
   AppendMenu(mm,MF_POPUP|MF_STRING,m6,"&Help");
   
   AppendMenu(m1,MF_STRING,F_LOAD,"&Load");
   AppendMenu(m1,MF_STRING,F_EXIT,"&Exit");

   AppendMenu(m2,MF_STRING,P_POPULATION,"&Populations");
   AppendMenu(m2,MF_STRING,P_EVOLUTION,"&Evolution");
   AppendMenu(m2,MF_STRING,P_LIFETIME,"&Lifetime");
   AppendMenu(m2,MF_STRING,P_DISPLAY,"&Display");
   AppendMenu(m2,MF_STRING,P_ENVIRONMENT,"Environments");
   AppendMenu(m2,MF_STRING,P_SAVE,"Save Parameters");

   AppendMenu(m3,MF_STRING,R_EVOLUTION,"&Evolution");
   AppendMenu(m3,MF_STRING,R_TEST,"&Test Ind.");
   AppendMenu(m3,MF_STRING,R_TESTB,"&Test Best Ind.");
   AppendMenu(m3,MF_STRING,R_MASTER,"&Master Tourn.");
   AppendMenu(m3,MF_STRING,R_SAMPLE,"&Sample Object");
   AppendMenu(m3,MF_STRING,R_TESTSC,"&Test Serial Conn.");
   AppendMenu(m3,MF_STRING,R_STOP,"&Stop");

   AppendMenu(m5,MF_STRING,D_SAMPLE,"&Sampled object");
   AppendMenu(m5,MF_STRING,D_FITNESS,"&Fitness");
   AppendMenu(m5,MF_STRING,D_IO_MAPS,"&Input/Outputs maps");
   AppendMenu(m5,MF_STRING,D_CLEAR,"&Clear Window");

   AppendMenu(m6,MF_STRING,H_ABOUT,"&About");


}


/* 
 * we disable menu options 
 * we disable all active procedures (but not display fitness)
 *  and parameters that cannot be changed during the process
 * we only allow to change some parameters
 */
void
disable_menu()
{

     EnableMenuItem(mm,R_EVOLUTION,MF_GRAYED);
     EnableMenuItem(mm,R_TEST,     MF_GRAYED);
     EnableMenuItem(mm,R_TESTB,    MF_GRAYED);
     EnableMenuItem(mm,R_MASTER,   MF_GRAYED);
     EnableMenuItem(mm,D_IO_MAPS,  MF_GRAYED);

}

/* 
 * we enable menu options 
 */
void
enable_menu()
{

     EnableMenuItem(mm,R_EVOLUTION,MF_ENABLED);
     EnableMenuItem(mm,R_TEST,     MF_ENABLED);
     EnableMenuItem(mm,R_TESTB,    MF_ENABLED);
     EnableMenuItem(mm,R_MASTER,   MF_ENABLED);
     EnableMenuItem(mm,D_IO_MAPS,  MF_ENABLED);

}


/*
 * The MAIN function which generate the main window
 */


int APIENTRY WinMain(HINSTANCE hinstm, HINSTANCE hinstmp, LPSTR lpc,  int cmsh)
{


    creamenu();

    wcm.style		=CS_SAVEBITS|CS_OWNDC; 
    wcm.lpfnWndProc	=(WNDPROC)WindowProcM; 
    wcm.cbClsExtra	=0; 
    wcm.cbWndExtra	=0; 
    wcm.hInstance	=hinstm; 
    wcm.hIcon		=NULL; 
    wcm.hCursor		=LoadCursor(NULL,IDC_ARROW); 
    wcm.hbrBackground=(HBRUSH)(COLOR_WINDOW+1); 
    wcm.lpszMenuName	=NULL; 
    wcm.lpszClassName=APPNAMEM; 

	RegisterClass(&wcm);

	hwndm=CreateWindow(
		APPNAMEM,
		APPNAMEM,
//       WS_OVERLAPPED | WS_CAPTION | WS_MINIMIZEBOX |WS_SYSMENU,
		WS_TILEDWINDOW,
		CW_USEDEFAULT,
		0,
		CW_USEDEFAULT,
		0,
		NULL,
		NULL,
		hinstm,
		NULL);

	hdcm = GetDC(hwndm);
	SetMenu(hwndm,mm);
        ShowWindow(hwndm,SW_SHOWNORMAL);

	kinit_graphics();

//	AllocConsole();

        /* 
	 * Load configurations and environment files
	 */
        init_khepsim();

        /*
	 * Create a separate tread for functions which need times
	 */
	hThread3 = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE) ciclomain, &dwThrdParam3, 0, &dwThreadId3);

        while(GetMessage(&msgm,NULL,0,0)) 
         {
	  DispatchMessage(&msgm);
         } 
	

	return 0;
 
}


/*
 * separate tread for time-consuming routines
 */ 
void 
ciclomain()

{


  struct individual *pind;	
  int    ind1, ind2;
  int    replication;
  int    g,gg;
  int    oldgenerations;
  int    oldamoebaepochs;
  int    oldseed;
  int    olddrawindividual;
  int    olddrawallepochs;
  int    olddrawallpopulation;
  FILE   *fp;
  FILE   *fopen();
  char   filebest[64];
  char   sbuffer[128];

  while (1 > 0)
  {
   // WE TEST AN INDIVIDUAL
   if (testindividual == 1)
    {
     disable_menu();
     select_window(0);
     kclear_device();
     olddrawindividual = drawindividual;
     olddrawallepochs;
     drawindividual=1;
     startx  = 50;
     starty  = 50;
     wendx   = 0;
     if (userscale != 999)
        {
	 scale = (float) userscale / (float) 100.0;
         startx = (int) ((float) startx * scale);
         starty = (int) ((float) starty * scale);
	 if (sim_real == 0)
	   wendx = (int) (env[cworld].dx * scale) + (startx * 2);
	  else
	   wendx = (int) (320 * scale) + (startx * 2);
        }
	else
	{
         if (graphsensors == 0 && draweights == 0 && drawselfselmaps == 0) 
	  {
	   if (sim_real == 0)
	   {
	    if (drawallepochs == 0)
	      set_scale(env[cworld].dx,env[cworld].dy);
	     else
	      set_scale((int) env[cworld].dx*((float)amoebaepochs / 2.0f),(int) env[cworld].dy*((float)amoebaepochs / 2.0f));
	   }
	   else
	   {
	     set_scale(320,500);
	   }
           startx = (int) ( (float) startx * scale);
           starty = (int) ( (float) starty * scale);
	  }
	  else
	  {
	    if (sim_real == 0)
	     {
	      set_scale(env[cworld].dx*3,env[cworld].dy);
	      wendx = (int) (env[cworld].dx * scale) + (startx * 2);
	     }
	     else
	     {
	      set_scale(320*3,500);
	      wendx = (int) (320 * scale) + (startx * 2);
	     }
            startx = (int) ( (float) startx * scale);
            starty = (int) ( (float) starty * scale);
            drawallepochs = 0;
	  }
	}

     ind1 = ind->dindividual;
     ind2 = 0;
     if (npopulations > 1)
      {
       pind = (ind + 1);
       ind2 = pind->dindividual;
      }
     if (ind1 < (nindividuals + opp_from_prev) && ind2 < (nindividuals + opp_from_prev))
        individual(startgeneration,ind1,0,ind2);
       else
	display_warning("current individual out of range");
     drawindividual = olddrawindividual;
     drawallepochs  = olddrawallepochs;
     testindividual = 0;
     userbreak      = 0;
     enable_menu();
   }
   // WE RUN EVOLUTION
   if (run_evolution > 0) 
	{
	   disable_menu();
	   select_window(0);
	   kclear_device();

	   oldseed = seed;
	   olddrawallepochs     = drawallepochs;
	   olddrawallpopulation = drawallpopulation;
	   drawallepochs = 0;

           if (drawindividual == 1)
	   {
            startx = (int) 50;
            starty = (int) 50;
            if (userscale != 999)
             {
	       scale = (float) userscale / (float) 100.0;
               startx = (int) ((float) startx * scale);
               starty = (int) ((float) starty * scale);
	       if (sim_real == 0)
	          wendx = (int) (env[cworld].dx * scale) + (startx * 2);
	         else
	          wendx = (int) (320 * scale) + (startx * 2);
             }
	    else
	    {
              if (graphsensors == 0 && draweights == 0 && drawselfselmaps == 0) 
	       {
                 if (sim_real == 0)
		  {
	          if (drawallpopulation == 0)
	            set_scale(env[cworld].dx,env[cworld].dy);	     
	           else
	            set_scale(env[cworld].dx*10,env[cworld].dy*10);
		  }
		  else
		  {
	           set_scale(320,500);
		  }
	       }
	       else
	       {
		 if (sim_real == 0)
		 {
	           set_scale(env[cworld].dx*3,env[cworld].dy);
	           wendx = (int) (env[cworld].dx * scale) + (startx * 2);
		 }
		 else
		 {
	           set_scale(320*3,500);
	           wendx = (int) (320 * scale) + (startx * 2);
		 }
                 startx = (int) ((float) startx * scale);
                 starty = (int) ((float) starty * scale);
                 drawallpopulation = 0;
	       }
	    }
	   }
  	   for (g=0; g < MAXGENERATIONS; g++)
  	     for (gg=0; gg < 4; gg++)
               astatfit[g][gg] = 0.0;
	   for (replication=0; replication < nreplications; replication++)
	    {
             srand(seed);
	     randomize_pop();
             /* load starting generation if > 0 */
             if (startgeneration > 0)
	      {
	        loadallw(startgeneration, "nofile");
	        if (opp_from_prev > 0 && npopulations == 2)
                  load_previous(startgeneration);
		sprintf(sbuffer,"stats%d.fit",seed);
	        loadstatistics(sbuffer);
		draw_statistics(1000,0);
	      }
	     generati();
	     if (userbreak == 1)
	       {
		break;
	       }
	       else
	       {
	        seed++;
	       }
	    }
           if (userbreak == 0 && nreplications > 1)
	    {
	     if ((fp=fopen("stat.fit", "w")) == NULL) 
	       {
		display_error("cannot write stat.fit file");
	       }	    
	     for(g=0;g<generations;g++)
	       {
	         for(gg=0;gg < (2*npopulations);gg++)
	           fprintf(fp,"%.3f ",astatfit[g][gg] / (double) nreplications);		
	         fprintf(fp,"\n");		
	       } 
	     fclose(fp);
	    }
	   seed               = oldseed;
	   drawallepochs      = olddrawallepochs;
	   drawallpopulation  = olddrawallpopulation;
	   userbreak          = 0;
	   run_evolution      = 0;
	   enable_menu();
	}
   // Master turnament
   if (run_masterturnament > 0)
	{
	 disable_menu();
         oldgenerations = generations;
	 generations = 1;
	 startgeneration = 0;
	 oldamoebaepochs = amoebaepochs;
	 amoebaepochs = nindividuals;
	 oldseed = seed;
	 masterturnament = 1;
	 olddrawallepochs     = drawallepochs;
	 olddrawallpopulation = drawallpopulation;
	 drawallepochs = 0;
	 if (npopulations == 2)
	 {
	   select_window(0);

           if (drawindividual == 1)
	   {
            startx = (int) 50;
            starty = (int) 50;
            if (userscale != 999)
             {
	       scale = (float) userscale / (float) 100.0;
               startx = (int) ((float) startx * scale);
               starty = (int) ((float) starty * scale);
	       if (sim_real == 0)
	         wendx = (int) (env[cworld].dx * scale) + (startx * 2);
	        else
	         wendx = (int) (320 * scale) + (startx * 2);
             }
	    else
	    {
              if (graphsensors == 0 && draweights == 0 && drawselfselmaps == 0) 
	       {
		 if (sim_real == 0)
		 {
	         if (drawallpopulation == 0)
	           set_scale(env[cworld].dx,env[cworld].dy);	     
	          else
	           set_scale(env[cworld].dx*10,env[cworld].dy*10);
		 }
		 else
		 {
	           set_scale(320,500);
		 }
	       }
	       else
	       {
		 if (sim_real == 0)
		 {
	          set_scale(env[cworld].dx*3,env[cworld].dy);
	          wendx = (int) (env[cworld].dx * scale) + (startx * 2);
		 }
		 else
		 {
	          set_scale(320*3,500);
	          wendx = (int) (320 * scale) + (startx * 2);
		 }
                 startx = (int) ((float) startx * scale);
                 starty = (int) ((float) starty * scale);
                 drawallpopulation = 0;
	       }
	    }
	   }
  	   for (g=0; g < MAXGENERATIONS; g++)
  	     for (gg=0; gg < 4; gg++)
               astatfit[g][gg] = 0.0;
	   for (replication=0; replication < nreplications; replication++)
	    {
 	     sprintf(filebest,"B1P0S%d.gen",seed);
	     loadallw(-1, filebest);
 	     sprintf(filebest,"B1P1S%d.gen",seed);
	     loadallw(-1, filebest);
	     generati();
	     if (userbreak == 1)
	       {
		break;
	       }
	       else
	       {
	        seed++;
	        randomize_pop();
		startgeneration = 0;
	       }
	    }
           if (userbreak == 0 && nreplications > 1)
	    {
	     if ((fp=fopen("master.fit", "w")) == NULL) 
	       {
		display_error("cannot write stat.fit file");
	       }	    
	     for(g=0;g<nindividuals;g++)
	       {
		 if (g < MAXGENERATIONS)
		 {
	          for(gg=0;gg < (2*npopulations);gg++)
	            fprintf(fp,"%.3f ",astatfit[g][gg] / (double) nreplications);		
	          fprintf(fp,"\n");		
		 }
	       } 
	     fclose(fp);
	    }
	  }
	  else
	  {
	   display_warning("sorry, I needs two coevolved populations");
	  }
	 generations = oldgenerations;
	 amoebaepochs = oldamoebaepochs;
	 seed = oldseed;
	 drawallepochs      = olddrawallepochs;
	 drawallpopulation  = olddrawallpopulation;
	 userbreak = 0;
	 run_masterturnament = 0;	
	 masterturnament = 0;
	 enable_menu();
        }

   // WE TEST THE SERIAL CONNECTION
   if (run_testsc == 1)
   {
      if (sim_real == 1)
       {
        while (userbreak == 0)
         {
          set_input_real(ind);
          draw_real_robot(ind);
         }
       }
       else
       {
        display_warning("You should select the real_robot mode first");
       }
      run_testsc = 0;
      userbreak = 0;
   }

  }

}


/*
 * routine di gestione of the main window
 */

LRESULT CALLBACK WindowProcM(HWND w,UINT m,WPARAM p1,LPARAM p2)
{ 
  
  HINSTANCE hmod;
  char   filename[64];
  char   sbuffer[128];
  char   *filesuffix;
  int    l,loadc;

  hmod=GetModuleHandle(NULL);
  
   switch (m)  
	{
	case WM_DESTROY: 
	  PostQuitMessage(0);
	  break;
	case WM_RBUTTONDOWN:
	  userbreak = 1;
	  break;
	case WM_COMMAND :
	       switch (p1)
		{
		case F_LOAD: 
			lpofn.lStructSize=sizeof(lpofn);
                        lpofn.hwndOwner=hwndm;
			lpofn.lpstrFilter = lpofn_filter;
			//lpofn.Flags = OFN_FILEMUSTEXIST;
			lpofn.nFilterIndex=1;
			lpofn.nMaxFile=200;
			filename[0] = NULL;
			lpofn.lpstrFile = filename;
                        GetOpenFileName(&lpofn);
			loadc = 0;
			l = strlen(filename);
			if (l > 4)
			{
                          filesuffix = (filename + (l - 3));
			  if ((strcmp(filesuffix,"gen") == 0) || (strcmp(filesuffix,"GEN") == 0))
			   {
			    if (cfloaded == 1)
			      loadallw(-1, filename);
			     else
			      display_warning("you should load a .cf file first");
			    loadc = 1;
			   }
			  if ((strcmp(filesuffix,"env") == 0) || (strcmp(filesuffix,"ENV") == 0))
			   {
                            strcpy(worldfiles,filename);
 			    if (load_world() == - 1)
                                 display_warning("unable to open environmental files");
			    loadc = 1;
			   }
			  if ((strcmp(filesuffix,".cf") == 0) || (strcmp(filesuffix,".CF") == 0))
			   {
			    if (cfloaded == 0)
			    {
			     if (load_parameters(filename) == 1)
			      {
				sprintf(fileroot,"%s", filename);
				if (cfloaded == 0)
				{
				  enable_menu();
				  cfloaded = 1;
				}
			      }
			    }
			    else
			    {
                              display_warning("you should exit and re-enter the program to load new parameters");
			    }
			    loadc = 1;

			   }
			  if ((strcmp(filesuffix,"fit") == 0) || (strcmp(filesuffix,"FIT") == 0))
			   {
			    loadstatistics(filename);
			    draw_statistics(1000,0);
			    loadc = 1;
			   }
			  if ((strcmp(filesuffix,"map") == 0) || (strcmp(filesuffix,"MAP") == 0))
			   {
			    draw_map(filename);
			    loadc = 1;
			   }
			  if ((strcmp(filesuffix,"sam") == 0) || (strcmp(filesuffix,"SAM") == 0))
			   {
	                    DialogBox(hmod,MAKEINTRESOURCE(IDD_DIALOG_SS),hwndm,boxprocss);
			    if (drawsampleob == 1)
			     {
                              load_obstacle(filename,  wall,     wallcf);
			      loadc = 1;
			     }
		            if (drawsampleob == 2)
			     {
                              load_obstacle(filename,  obst,     obstcf);
			      loadc = 1;
			     }
			    if (drawsampleob == 3)
			     {
                              load_obstacle(filename,  sobst,    sobstcf);
			      loadc = 1;
			     }
			    if (drawsampleob == 4)
			     {
                              load_obstacle(filename,  light,    lightcf);
			      loadc = 1;
			     }
			   }
			}
			if (filename[0] != NULL && loadc == 0)
			 {
			   sprintf(sbuffer,"unable to load the file: %s", filename);
			   display_warning(sbuffer);
			 }
			break;
		case F_EXIT:PostQuitMessage(0);
			break; 
		// Parameters menu'
		case P_POPULATION: 
			DialogBox(hmod,MAKEINTRESOURCE(IDD_DIALOG_P2),hwndm,boxproc2);
			break; 
		case P_EVOLUTION: 
			DialogBox(hmod,MAKEINTRESOURCE(IDD_DIALOG_P3),hwndm,boxproc3);
			break; 
		case P_LIFETIME: 
			DialogBox(hmod,MAKEINTRESOURCE(IDD_DIALOG_P4),hwndm,boxproc4);
			break; 
		case P_ENVIRONMENT: 
			DialogBox(hmod,MAKEINTRESOURCE(IDD_DIALOG_P6),hwndm,boxproc6);
			break; 
		case P_DISPLAY: 
			DialogBox(hmod,MAKEINTRESOURCE(IDD_DIALOG_P5),hwndm,boxproc5);
			break;
                case P_SAVE: 
		        save_parameters(fileroot);
			break;
		// run menu
                case R_EVOLUTION:
			if ((env[cworld].dx == 0 || env[cworld].dy == 0) && sim_real == 0)
			  display_warning("the environment has not been properly set");
			 else
                          run_evolution = 1;
			fs=1;
			break;
		case R_TEST:
			if ((env[cworld].dx == 0 || env[cworld].dy == 0) && sim_real == 0)
			  display_warning("the environment has not been properly set");
			 else
			  testindividual = 1;
			fs=1;
                        break;
		case R_TESTB:
			select_besti();
			if ((env[cworld].dx == 0 || env[cworld].dy == 0) && sim_real == 0)
			  display_warning("the environment has not been properly set");
			 else
			  testindividual = 1;
			fs=1;
                        break;
		case R_MASTER:
			if ((env[cworld].dx == 0 || env[cworld].dy == 0) && sim_real == 0)
			  display_warning("the environment has not been properly set");
			 else
			  run_masterturnament = 1;
			fs=1;
                        break;
		case R_SAMPLE:
			if (sim_real == 1)
			{
	                 DialogBox(hmod,MAKEINTRESOURCE(IDD_DIALOG_SA),hwndm,boxprocsa);
                         while (sampleob > 0)
			 {
	                  if (sampleob == 1)
		           {
			    objtosample   = wall;
			    objtosamplecf = wallcf;
			   }
	                  if (sampleob == 2)
		           {
			    objtosample   = obst;
			    objtosamplecf = obstcf;
			   }
	                  if (sampleob == 3)
		           {
			    objtosample   = sobst;
			    objtosamplecf = sobstcf;
			   }
	                  if (sampleob == 4)
		           {
			    objtosample   = light;
			    objtosamplecf = lightcf;
			   }
			  if (samplesave == 1)
			   {
	                     if (sampleob == 1)
			      {
                               save_obstacle("wall.sam",  wall, wallcf);
			       kmessage("saved file wall.sam");
			      }
                             if (sampleob == 2)
			      {
                               save_obstacle("round.sam", obst, obstcf);
			       kmessage("saved file round.sam");
			      }
                             if (sampleob == 3)
			      { 
                               save_obstacle("small.sam", sobst, sobstcf);
			       kmessage("saved file small.sam");
			      }
                             if (sampleob == 4)
			      {
                               save_obstacle("light.sam", light, lightcf);
			       kmessage("saved file light.sam");
			      }
			     sampleob = 0;
			     samplesave = 0;
			   }
			  if (sampleob > 0)
			   {
			    if (samplenturns > 30)
			     {
			      samplenturns = 30;
			      display_warning("you can sample up to 30 distances");
			     }
			    if (sampleturn >= samplenturns)
			     {
			      sampleturn = samplenturns - 1;
			      display_warning("you can sample up to n.turns distances");
			     }
                            objtosamplecf[2] = samplenturns;
                            objtosamplecf[3] = sampleinitdist;
                            objtosamplecf[4] = sampleinterdist;
                            sample_turn(sampleturn, objtosample, objtosamplecf);
			   }
	                 DialogBox(hmod,MAKEINTRESOURCE(IDD_DIALOG_SA),hwndm,boxprocsa);
			 }
			}
			else
			{
                          display_warning("You should select the real_robot mode first");
			}
			fs=1;			    
			break;
		case R_TESTSC:
			run_testsc = 1;
			fs=1;			    
			break;
		case R_STOP:
			userbreak = 1;
			fs=1;			    
			break;
                // display menu
		case D_SAMPLE :
	                DialogBox(hmod,MAKEINTRESOURCE(IDD_DIALOG_SS),hwndm,boxprocss);
		        select_window(0);
                        kclear_device();
			startx= 20; 
                        starty= 20;
			scale = (float) 1.0;
			if (drawsampleob == 1)
                          draw_sample(wall,wallcf);
			if (drawsampleob == 2)
                          draw_sample(obst,obstcf);
			if (drawsampleob == 3)
                          draw_sample(sobst,sobstcf);
			if (drawsampleob == 4)
                          draw_sample(light,lightcf);
			fs=1;
			break;
		case D_FITNESS :
		        select_window(0);
			startx= 50; 
                        starty= 50;
                        draw_statistics(1000,0);
			fs=1;
			break;
                case D_IO_MAPS :
		        select_window(0);
			draw_io_maps();
			fs=1;
			break;
                case D_CLEAR :
		        kclear_device();
			fs=1;
			break;
		case H_ABOUT: 
			DialogBox(hmod,MAKEINTRESOURCE(IDD_DIALOG_HLP),hwndm,boxprochlp);
			break;
        }
	break;
	case WM_PAINT:
		BeginPaint(hwndm,&psm);
  		EndPaint(hwndm,&psm);
		return (DefWindowProc(w,m,p1,p2));
	default: return (DefWindowProc(w,m,p1,p2));}
    return (DefWindowProc(w,m,p1,p2));
}


/*
 * if parameters that need a re-allocation of the population
 * has been changed we disable all active menu so that
 * the user can only save the new parameters and exit
 */
void
check_par_box2()

{

if (oldnpopulations    != npopulations)
  parmodified = 1;
if (oldbestfathers     != bestfathers)
  parmodified = 1; 
if (oldnkids           != nkids)
  parmodified = 1;
if (oldopp_from_prev   != opp_from_prev)
  parmodified = 1;
if (old1cameraunits    != ind[0].cameraunits)
  parmodified = 1;
if (old2cameraunits    != ind[1].cameraunits)
  parmodified = 1;
if (old1nhiddens       != ind[0].nhiddens)
  parmodified = 1;
if (old2nhiddens       != ind[1].nhiddens)
  parmodified = 1;
if (old1input_outputs  != ind[0].input_outputs)
  parmodified = 1;
if (old2input_outputs  != ind[1].input_outputs)
  parmodified = 1;

if (parmodified == 1)
 {
  disable_menu();
  display_warning("please save the new parameters, exit, and re-enter the program");
  parmodified = 0;
 }

}



/*
 * handling dialog box Parameters->Population
 */

BOOL CALLBACK boxproc2(HWND w,UINT m,WPARAM p1,LPARAM p2)

{

char   sbuffer[64];

switch(m)
 {
   case WM_INITDIALOG:
            oldnpopulations   = npopulations;
            oldbestfathers    = bestfathers;
            oldnkids          = nkids;
            oldopp_from_prev  = opp_from_prev;
            old1cameraunits   = ind[0].cameraunits;
            old2cameraunits   = ind[1].cameraunits;
            old1nhiddens      = ind[0].nhiddens;
            old2nhiddens      = ind[1].nhiddens;
            old1input_outputs = ind[0].input_outputs;
            old2input_outputs = ind[1].input_outputs;
	    if (testindividual ==1 || run_evolution == 1 || run_masterturnament == 1)
	       {
		EnableWindow(GetDlgItem(w,IDC_RAP24IF),FALSE);
		EnableWindow(GetDlgItem(w,IDC_RAP26IF),FALSE);
		EnableWindow(GetDlgItem(w,IDC_RAP28IF),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2LI),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2GR),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2C5),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2C5B),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2OP),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2LB),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2BA),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2LI2),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2EL),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2MO),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2WE),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2G),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2EM),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2FR),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2AT),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2HL),FALSE);
		EnableWindow(GetDlgItem(w,IDC_CHP2FX),FALSE);

		EnableWindow(GetDlgItem(w,IDC_EDIGNP),FALSE);
		EnableWindow(GetDlgItem(w,IDC_EDIGRI),FALSE);
		EnableWindow(GetDlgItem(w,IDC_EDIGOF),FALSE);
		EnableWindow(GetDlgItem(w,IDC_EDIGOP),FALSE);
		EnableWindow(GetDlgItem(w,IDC_EDP2CU),FALSE);
		EnableWindow(GetDlgItem(w,IDC_EDP2NH),FALSE);
		EnableWindow(GetDlgItem(w,IDC_EDP2IO),FALSE);
	       }

	    if (ind[dpopulation].nifsensors == 4)
		CheckDlgButton(w,IDC_RAP24IF,1);
	       else
		CheckDlgButton(w,IDC_RAP24IF,0);
	    if (ind[dpopulation].nifsensors == 6)
		CheckDlgButton(w,IDC_RAP26IF,1);
	       else
		CheckDlgButton(w,IDC_RAP26IF,0);
	    if (ind[dpopulation].nifsensors == 8)
		CheckDlgButton(w,IDC_RAP28IF,1);
	       else
		CheckDlgButton(w,IDC_RAP28IF,0);
	    if (ind[dpopulation].lightsensors == 0)
		CheckDlgButton(w,IDC_CHP2LI,0);
	       else
		CheckDlgButton(w,IDC_CHP2LI,1);
	    if (ind[dpopulation].groundsensor == 0)
		CheckDlgButton(w,IDC_CHP2GR,0);
	       else
		CheckDlgButton(w,IDC_CHP2GR,1);
	    if (ind[dpopulation].camerafive == 0)
		CheckDlgButton(w,IDC_CHP2C5,0);
	       else
		CheckDlgButton(w,IDC_CHP2C5,1);
	    if (ind[dpopulation].newcamerafive == 0)
		CheckDlgButton(w,IDC_CHP2C5B,0);
	       else
		CheckDlgButton(w,IDC_CHP2C5B,1);
	    if (ind[dpopulation].oppsensor == 0)
		CheckDlgButton(w,IDC_CHP2OP,0);
	       else
		CheckDlgButton(w,IDC_CHP2OP,1);
	    if (ind[dpopulation].objectsensor == 0)
		CheckDlgButton(w,IDC_CHP2LB,0);
	       else
		CheckDlgButton(w,IDC_CHP2LB,1);
	    if (ind[dpopulation].battery == 0)
		CheckDlgButton(w,IDC_CHP2BA,0);
	       else
		CheckDlgButton(w,IDC_CHP2BA,1);
	    if (ind[dpopulation].light2sensors == 0)
		CheckDlgButton(w,IDC_CHP2LI2,0);
	       else
		CheckDlgButton(w,IDC_CHP2LI2,1);
	    if (ind[dpopulation].elman_net == 0)
		CheckDlgButton(w,IDC_CHP2EL,0);
	       else
		CheckDlgButton(w,IDC_CHP2EL,1);
	    if (ind[dpopulation].motmemory == 0)
		CheckDlgButton(w,IDC_CHP2MO,0);
	       else
		CheckDlgButton(w,IDC_CHP2MO,1);
	    if (ind[dpopulation].wheelmotors == 0)
		CheckDlgButton(w,IDC_CHP2WE,0);
	       else
		CheckDlgButton(w,IDC_CHP2WE,1);
	    if (ind[dpopulation].gripper == 0)
		CheckDlgButton(w,IDC_CHP2G,0);
	       else
		CheckDlgButton(w,IDC_CHP2G,1);
	    if (ind[dpopulation].modularity == 0)
		CheckDlgButton(w,IDC_CHP2EM,0);
	       else
		CheckDlgButton(w,IDC_CHP2EM,1);
	    if (ind[dpopulation].randomweights == 0)
		CheckDlgButton(w,IDC_CHP2RW,0);
	       else
		CheckDlgButton(w,IDC_CHP2RW,1);
	    if (ind[dpopulation].autoteach == 0)
		CheckDlgButton(w,IDC_CHP2AT,0);
	       else
		CheckDlgButton(w,IDC_CHP2AT,1);
	    if (ind[dpopulation].hebbian_learning == 0)
		CheckDlgButton(w,IDC_CHP2HL,0);
	       else
		CheckDlgButton(w,IDC_CHP2HL,1);
	    if (ind[dpopulation].fixed == 0)
		CheckDlgButton(w,IDC_CHP2FX,0);
	       else
		CheckDlgButton(w,IDC_CHP2FX,1);
            SetDlgItemText(w,IDC_EDIP2FN,fileroot);
	    SetDlgItemInt(w,IDC_EDIGNP,npopulations,0);
	    SetDlgItemInt(w,IDC_EDIGCP,dpopulation,0);
	    SetDlgItemInt(w,IDC_EDP2ID,ind[dpopulation].dindividual,0);
	    SetDlgItemInt(w,IDC_EDIGRI,bestfathers,0);
	    SetDlgItemInt(w,IDC_EDIGOF,nkids,0);
	    SetDlgItemInt(w,IDC_EDIGOP,opp_from_prev,0);
	    SetDlgItemInt(w,IDC_EDP2CU,ind[dpopulation].cameraunits,0);
	    SetDlgItemInt(w,IDC_EDP2CR,ind[dpopulation].camerarange,0);
	    sprintf(sbuffer,"%.1f",ind[dpopulation].wrange);
            SetDlgItemText(w,IDC_EDP2WR,sbuffer);
	    SetDlgItemInt(w,IDC_EDP2FF,ind[dpopulation].ffitness,0);
	    SetDlgItemInt(w,IDC_EDP2NH,ind[dpopulation].nhiddens,0);
	    SetDlgItemInt(w,IDC_EDP2IO,ind[dpopulation].input_outputs,0);
	    return TRUE;
 case WM_COMMAND:
    switch(HIWORD(p1))
     { 
        case BN_CLICKED:
	  switch (LOWORD(p1))
	   {
	     case IDOK: 
		 EndDialog(w,0);
		 check_par_box2();
		 break;
	     case IDC_RAP24IF:
		 if (ind[dpopulation].nifsensors == 4)
		   {
		    ind[dpopulation].nifsensors = 0;
		    CheckDlgButton(w,IDC_RAP24IF,0);
		   }
		  else
		   {
		   ind[dpopulation].nifsensors = 4;
		   CheckDlgButton(w,IDC_RAP24IF,1);
		   CheckDlgButton(w,IDC_RAP26IF,0);
		   CheckDlgButton(w,IDC_RAP28IF,0);
		  }
                 parmodified=1;
		 break;
	     case IDC_RAP26IF:
		 if (ind[dpopulation].nifsensors == 6)
		   {
		    ind[dpopulation].nifsensors = 0;
		    CheckDlgButton(w,IDC_RAP26IF,0);
		   }
		  else
		   {
		   ind[dpopulation].nifsensors = 6;
		   CheckDlgButton(w,IDC_RAP24IF,0);
		   CheckDlgButton(w,IDC_RAP26IF,1);
		   CheckDlgButton(w,IDC_RAP28IF,0);
		  }
                 parmodified=1;
		 break;
	     case IDC_RAP28IF:
		 if (ind[dpopulation].nifsensors == 8)
		   {
		    ind[dpopulation].lightsensors = 0;
		    CheckDlgButton(w,IDC_RAP28IF,0);
		   }
		  else
		   {
		   ind[dpopulation].nifsensors = 8;
		   CheckDlgButton(w,IDC_RAP24IF,0);
		   CheckDlgButton(w,IDC_RAP26IF,0);
		   CheckDlgButton(w,IDC_RAP28IF,1);
		  }
                parmodified=1;
	        break;
	     case IDC_CHP2LI:
		 if (ind[dpopulation].lightsensors == 0)
		   {
		    ind[dpopulation].lightsensors = 1;
		    CheckDlgButton(w,IDC_CHP2LI,1);
		   }
		  else
		   {
		    ind[dpopulation].lightsensors = 0;
		    CheckDlgButton(w,IDC_CHP2LI,0);
		  }
                 parmodified=1;
		 break;
	     case IDC_CHP2GR:
		 if (ind[dpopulation].groundsensor == 0)
		   {
		    ind[dpopulation].groundsensor = 1;
		    CheckDlgButton(w,IDC_CHP2GR,1);
		   }
		  else
		   {
		    ind[dpopulation].groundsensor = 0;
		    CheckDlgButton(w,IDC_CHP2GR,0);
		  }
                 parmodified=1;
		 break;
	     case IDC_CHP2C5:
		 if (ind[dpopulation].camerafive == 0)
		   {
		    ind[dpopulation].camerafive = 1;
		    CheckDlgButton(w,IDC_CHP2C5,1);
		   }
		  else
		   {
		    ind[dpopulation].camerafive = 0;
		    CheckDlgButton(w,IDC_CHP2C5,0);
		   }
                 parmodified=1;
		 break;
	     case IDC_CHP2C5B:
		 if (ind[dpopulation].newcamerafive == 0)
		   {
		    ind[dpopulation].newcamerafive = 1;
		    CheckDlgButton(w,IDC_CHP2C5B,1);
		   }
		  else
		   {
		    ind[dpopulation].newcamerafive = 0;
		    CheckDlgButton(w,IDC_CHP2C5B,0);
		   }
                 parmodified=1;
		 break;
	     case IDC_CHP2OP:
		 if (ind[dpopulation].oppsensor == 0)
		   {
		    ind[dpopulation].oppsensor = 1;
		    CheckDlgButton(w,IDC_CHP2OP,1);
		   }
		  else
		   {
		   ind[dpopulation].oppsensor = 0;
		   CheckDlgButton(w,IDC_CHP2OP,0);
		  }
                 parmodified=1;
		 break;
	     case IDC_CHP2BA:
		 if (ind[dpopulation].battery == 0)
		   {
		    ind[dpopulation].battery = 1;
		    CheckDlgButton(w,IDC_CHP2BA,1);
		   }
		  else
		   {
		   ind[dpopulation].battery = 0;
		   CheckDlgButton(w,IDC_CHP2BA,0);
		  }
                 parmodified=1;
		 break;
	     case IDC_CHP2LI2:
		 if (ind[dpopulation].light2sensors == 0)
		   {
		    ind[dpopulation].light2sensors = 1;
		    CheckDlgButton(w,IDC_CHP2LI2,1);
		   }
		  else
		   {
		   ind[dpopulation].light2sensors = 0;
		   CheckDlgButton(w,IDC_CHP2LI2,0);
		  }
                 parmodified=1;
		 break;
	     case IDC_CHP2LB:
		 if (ind[dpopulation].objectsensor == 0)
		   {
		    ind[dpopulation].objectsensor = 1;
		    CheckDlgButton(w,IDC_CHP2LB,1);
		   }
		  else
		   {
		   ind[dpopulation].objectsensor = 0;
		   CheckDlgButton(w,IDC_CHP2LB,0);
		  }
                 parmodified=1;
		 break;
	     case IDC_CHP2EL:
		 if (ind[dpopulation].elman_net == 0)
		   {
		    ind[dpopulation].elman_net = 1;
		    CheckDlgButton(w,IDC_CHP2EL,1);
		   }
		  else
		   {
		    ind[dpopulation].elman_net = 0;
		    CheckDlgButton(w,IDC_CHP2EL,0);
		   }
                 parmodified=1;
		 break;
	     case IDC_CHP2MO:
		 if (ind[dpopulation].motmemory == 0)
		   {
		    ind[dpopulation].motmemory = 1;
		    CheckDlgButton(w,IDC_CHP2MO,1);
		   }
		  else
		   {
		    ind[dpopulation].motmemory = 0;
		    CheckDlgButton(w,IDC_CHP2MO,0);
		   }
                 parmodified=1;
		 break;
	     case IDC_CHP2WE:
		 if (ind[dpopulation].wheelmotors == 0)
		   {
		    ind[dpopulation].wheelmotors = 1;
		    CheckDlgButton(w,IDC_CHP2WE,1);
		   }
		  else
		   {
		   ind[dpopulation].wheelmotors = 0;
		   CheckDlgButton(w,IDC_CHP2WE,0);
		  }
                 parmodified=1;
		 break;
	     case IDC_CHP2G:
		 if (ind[dpopulation].gripper == 0)
		   {
		    ind[dpopulation].gripper = 1;
		    CheckDlgButton(w,IDC_CHP2G,1);
		   }
		  else
		   {
		   ind[dpopulation].gripper = 0;
		   CheckDlgButton(w,IDC_CHP2G,0);
		  }
                 parmodified=1;
		 break;
	     case IDC_CHP2AT:
		 if (ind[dpopulation].autoteach == 0)
		   {
		    ind[dpopulation].autoteach = 1;
		    CheckDlgButton(w,IDC_CHP2AT,1);
		   }
		  else
		   {
		    ind[dpopulation].autoteach = 0;
		    CheckDlgButton(w,IDC_CHP2AT,0);
		   }
                 parmodified=1;
		 break;
	     case IDC_CHP2HL:
		 if (ind[dpopulation].hebbian_learning == 0)
		   {
		    ind[dpopulation].hebbian_learning = 1;
		    CheckDlgButton(w,IDC_CHP2HL,1);
		   }
		  else
		   {
		    ind[dpopulation].hebbian_learning = 0;
		    CheckDlgButton(w,IDC_CHP2HL,0);
		   }
                 parmodified=1;
		 break;
	     case IDC_CHP2RW:
		 if (ind[dpopulation].randomweights == 0)
		   {
		    ind[dpopulation].randomweights = 1;
		    CheckDlgButton(w,IDC_CHP2RW,1);
		   }
		  else
		   {
		    ind[dpopulation].randomweights = 0;
		    CheckDlgButton(w,IDC_CHP2RW,0);
		   }
		 break;
	     case IDC_CHP2FX:
		 if (ind[dpopulation].fixed == 0)
		   {
		    ind[dpopulation].fixed = 1;
		    CheckDlgButton(w,IDC_CHP2FX,1);
		   }
		  else
		   {
		    ind[dpopulation].fixed = 0;
		    CheckDlgButton(w,IDC_CHP2FX,0);
		   }
                 parmodified=1;
		 break;
	     case IDC_CHP2EM:
		 if (ind[dpopulation].modularity == 0)
		   {
		    ind[dpopulation].modularity = 2;
		    CheckDlgButton(w,IDC_CHP2EM,1);
		   }
		  else
		   {
		    ind[dpopulation].modularity = 0;
		    CheckDlgButton(w,IDC_CHP2EM,0);
		   }
                 parmodified=1;
		 break;
           }
        case EN_CHANGE:
	  switch (LOWORD(p1))
	   {	 
	     // if the user changes the current population we redisplay all variables
	     case IDC_EDIGCP: 
		  dpopulation  =GetDlgItemInt(w,IDC_EDIGCP,NULL,0);
		  if (dpopulation >= 2)
		      {
			display_warning("number of world cannot exceed 2");
			dpopulation = 1;
			SetDlgItemInt(w,IDC_EDIGCP,dpopulation,0);
		      }
	    if (ind[dpopulation].nifsensors == 4)
		CheckDlgButton(w,IDC_RAP24IF,1);
	       else
		CheckDlgButton(w,IDC_RAP24IF,0);
	    if (ind[dpopulation].nifsensors == 6)
		CheckDlgButton(w,IDC_RAP26IF,1);
	       else
		CheckDlgButton(w,IDC_RAP26IF,0);
	    if (ind[dpopulation].nifsensors == 8)
		CheckDlgButton(w,IDC_RAP28IF,1);
	       else
		CheckDlgButton(w,IDC_RAP28IF,0);
	    if (ind[dpopulation].lightsensors == 0)
		CheckDlgButton(w,IDC_CHP2LI,0);
	       else
		CheckDlgButton(w,IDC_CHP2LI,1);
	    if (ind[dpopulation].groundsensor == 0)
		CheckDlgButton(w,IDC_CHP2GR,0);
	       else
		CheckDlgButton(w,IDC_CHP2GR,1);
	    if (ind[dpopulation].camerafive == 0)
		CheckDlgButton(w,IDC_CHP2C5,0);
	       else
		CheckDlgButton(w,IDC_CHP2C5,1);
	    if (ind[dpopulation].newcamerafive == 0)
		CheckDlgButton(w,IDC_CHP2C5B,0);
	       else
		CheckDlgButton(w,IDC_CHP2C5B,1);
	    if (ind[dpopulation].oppsensor == 0)
		CheckDlgButton(w,IDC_CHP2OP,0);
	       else
		CheckDlgButton(w,IDC_CHP2OP,1);
	    if (ind[dpopulation].objectsensor == 0)
		CheckDlgButton(w,IDC_CHP2LB,0);
	       else
		CheckDlgButton(w,IDC_CHP2LB,1);
	    if (ind[dpopulation].battery == 0)
		CheckDlgButton(w,IDC_CHP2BA,0);
	       else
		CheckDlgButton(w,IDC_CHP2BA,1);
	    if (ind[dpopulation].light2sensors == 0)
		CheckDlgButton(w,IDC_CHP2LI2,0);
	       else
		CheckDlgButton(w,IDC_CHP2LI2,1);
	    if (ind[dpopulation].elman_net == 0)
		CheckDlgButton(w,IDC_CHP2EL,0);
	       else
		CheckDlgButton(w,IDC_CHP2EL,1);
	    if (ind[dpopulation].motmemory == 0)
		CheckDlgButton(w,IDC_CHP2MO,0);
	       else
		CheckDlgButton(w,IDC_CHP2MO,1);
	    if (ind[dpopulation].wheelmotors == 0)
		CheckDlgButton(w,IDC_CHP2WE,0);
	       else
		CheckDlgButton(w,IDC_CHP2WE,1);
	    if (ind[dpopulation].gripper == 0)
		CheckDlgButton(w,IDC_CHP2G,0);
	       else
		CheckDlgButton(w,IDC_CHP2G,1);
	    if (ind[dpopulation].modularity == 0)
		CheckDlgButton(w,IDC_CHP2EM,0);
	       else
		CheckDlgButton(w,IDC_CHP2EM,1);
	    if (ind[dpopulation].randomweights == 0)
		CheckDlgButton(w,IDC_CHP2RW,0);
	       else
		CheckDlgButton(w,IDC_CHP2RW,1);
	    if (ind[dpopulation].autoteach == 0)
		CheckDlgButton(w,IDC_CHP2AT,0);
	       else
		CheckDlgButton(w,IDC_CHP2AT,1);
	    if (ind[dpopulation].hebbian_learning == 0)
		CheckDlgButton(w,IDC_CHP2HL,0);
	       else
		CheckDlgButton(w,IDC_CHP2HL,1);
	    if (ind[dpopulation].fixed == 0)
		CheckDlgButton(w,IDC_CHP2FX,0);
	       else
		CheckDlgButton(w,IDC_CHP2FX,1);
            SetDlgItemText(w,IDC_EDIP2FN,fileroot);
	    SetDlgItemInt(w,IDC_EDIGNP,npopulations,0);
	    SetDlgItemInt(w,IDC_EDP2ID,ind[dpopulation].dindividual,0);
	    SetDlgItemInt(w,IDC_EDIGRI,bestfathers,0);
	    SetDlgItemInt(w,IDC_EDIGOF,nkids,0);
	    SetDlgItemInt(w,IDC_EDIGOP,opp_from_prev,0);
	    SetDlgItemInt(w,IDC_EDP2CU,ind[dpopulation].cameraunits,0);
	    SetDlgItemInt(w,IDC_EDP2CR,ind[dpopulation].camerarange,0);
	    sprintf(sbuffer,"%.1f",ind[dpopulation].wrange);
            SetDlgItemText(w,IDC_EDP2WR,sbuffer);
	    SetDlgItemInt(w,IDC_EDP2FF,ind[dpopulation].ffitness,0);
	    SetDlgItemInt(w,IDC_EDP2NH,ind[dpopulation].nhiddens,0);
	    SetDlgItemInt(w,IDC_EDP2IO,ind[dpopulation].input_outputs,0);
	     break;
	     case IDC_EDIP2FN: GetDlgItemText(w,IDC_EDIP2FN,fileroot,64);
	       break;
	     case IDC_EDIGNP: npopulations =GetDlgItemInt(w,IDC_EDIGNP,NULL,0);
	       //if (npopulations != oldnpopulations)
	       // saveandexit_box2(w);
	       break;
	     case IDC_EDP2ID: ind[dpopulation].dindividual =GetDlgItemInt(w,IDC_EDP2ID,NULL,0);
	       break;
	     case IDC_EDIGRI: bestfathers  =GetDlgItemInt(w,IDC_EDIGRI,NULL,0);
	       //if (bestfathers != oldbestfathers)
               //  saveandexit_box2(w);
	       break;
	     case IDC_EDIGOF: nkids        =GetDlgItemInt(w,IDC_EDIGOF,NULL,0);
               //saveandexit_box2(w);
	       break;
	     case IDC_EDIGOP: opp_from_prev=GetDlgItemInt(w,IDC_EDIGOP,NULL,0);
               //saveandexit_box2(w);
	       break;
	     case IDC_EDP2CU: ind[dpopulation].cameraunits = GetDlgItemInt(w,IDC_EDP2CU,NULL,0);
               //saveandexit_box2(w);	     
	       break;
	     case IDC_EDP2CR: ind[dpopulation].camerarange = GetDlgItemInt(w,IDC_EDP2CR,NULL,0);
               //saveandexit_box2(w);
	       break;
	     case IDC_EDP2WR: GetDlgItemText(w,IDC_EDP2WR,sbuffer,64); sscanf(sbuffer,"%f", &ind[dpopulation].wrange);
	       break;
	     case IDC_EDP2FF: ind[dpopulation].ffitness    =GetDlgItemInt(w,IDC_EDP2FF,NULL,0);
	       break;
	     case IDC_EDP2NH: ind[dpopulation].nhiddens    =GetDlgItemInt(w,IDC_EDP2NH,NULL,0);
               //saveandexit_box2(w);
	       break;
	     case IDC_EDP2IO: ind[dpopulation].input_outputs =GetDlgItemInt(w,IDC_EDP2IO,NULL,0);
               //saveandexit_box2(w);
	       break;

           }
    }	 
 }

return FALSE;
}


/*
 * handles the dialog box Parameters->Evolution
 */

BOOL CALLBACK boxproc3(HWND w,UINT m,WPARAM p1,LPARAM p2)
{


switch(m)
 {
 case WM_INITDIALOG :
	    SetDlgItemInt(w,IDC_EDIP3NG,generations,0);
	    SetDlgItemInt(w,IDC_EDIP3SG,startgeneration,0);
	    SetDlgItemInt(w,IDC_EDIP3NM,percmut,0);
	    SetDlgItemInt(w,IDC_EDIP3SE,seed,0);
	    SetDlgItemInt(w,IDC_EDIP3SB,delfile,0);
	    SetDlgItemInt(w,IDC_EDIP3NR,nreplications,0);
	   if (all_of_fame == 0)
		CheckDlgButton(w,IDC_CHEP3MT,0);
	       else
		CheckDlgButton(w,IDC_CHEP3MT,1);
	   if (sim_real == 0)
		CheckDlgButton(w,IDC_CHP3RR,0);
	       else
		CheckDlgButton(w,IDC_CHP3RR,1);
	   if (serialport == 1)
	       {
		CheckDlgButton(w,IDC_RAP3P1,1);
		CheckDlgButton(w,IDC_RAP3P2,0);
	       }
	   if (serialport == 2)
	       {
		CheckDlgButton(w,IDC_RAP3P1,0);
		CheckDlgButton(w,IDC_RAP3P2,1);
	       }
	   if (serialspeed == 9600)
	       {
		CheckDlgButton(w,IDC_RAP3S1,1);
		CheckDlgButton(w,IDC_RAP3S2,0);
		CheckDlgButton(w,IDC_RAP3S3,0);
	       }
	   if (serialspeed == 19200)
	       {
		CheckDlgButton(w,IDC_RAP3S1,0);
		CheckDlgButton(w,IDC_RAP3S2,1);
		CheckDlgButton(w,IDC_RAP3S3,0);
	       }
	   if (serialspeed == 38400)
	       {
		CheckDlgButton(w,IDC_RAP3S1,0);
		CheckDlgButton(w,IDC_RAP3S2,0);
		CheckDlgButton(w,IDC_RAP3S3,1);
	       }
	   return TRUE;
 case WM_COMMAND:
    switch(HIWORD(p1))
     { 
        case BN_CLICKED:
	  switch (LOWORD(p1))
	   {
	     case IDOK:
		  EndDialog(w,0);
		  break;
	     case IDC_CHEP3MT:
		 if (all_of_fame == 0)
		   {
		    all_of_fame = 1;
		    CheckDlgButton(w,IDC_CHEP3MT,1);
		   }
		  else
		   {
		   all_of_fame = 0;
		   CheckDlgButton(w,IDC_CHEP3MT,0);
		  }
		 break;
	     case IDC_CHP3RR:
		 if (sim_real == 0)
		   {
		    sim_real = 1;
		    aprecom();
		    CheckDlgButton(w,IDC_CHP3RR,1);
		   }
		  else
		   {
		    sim_real = 0;
		    CheckDlgButton(w,IDC_CHP3RR,0);
		   }
		 break;
	     case IDC_RAP3P1:
		 CheckDlgButton(w,IDC_RAP3P1,1);
		 CheckDlgButton(w,IDC_RAP3P2,0);
		 serialport = 1;
		 break;
	     case IDC_RAP3P2:
		 CheckDlgButton(w,IDC_RAP3P1,0);
		 CheckDlgButton(w,IDC_RAP3P2,1);
		 serialport = 2;
		 break;
	     case IDC_RAP3S1:
		 CheckDlgButton(w,IDC_RAP3S1,1);
		 CheckDlgButton(w,IDC_RAP3S2,0);
		 CheckDlgButton(w,IDC_RAP3S3,0);
		 serialspeed = 9600;
		 break;
	     case IDC_RAP3S2:
		 CheckDlgButton(w,IDC_RAP3S1,0);
		 CheckDlgButton(w,IDC_RAP3S2,1);
		 CheckDlgButton(w,IDC_RAP3S3,0);
		 serialspeed = 19200;
		 break;
	     case IDC_RAP3S3:
		 CheckDlgButton(w,IDC_RAP3S1,0);
		 CheckDlgButton(w,IDC_RAP3S2,0);
		 CheckDlgButton(w,IDC_RAP3S3,1);
		 serialspeed = 38400;
		 break;
           }
        case EN_CHANGE:
	  switch (LOWORD(p1))
	   {	 
	     case IDC_EDIP3NG: generations    =GetDlgItemInt(w,IDC_EDIP3NG,NULL,0);break;
	     case IDC_EDIP3SG: startgeneration=GetDlgItemInt(w,IDC_EDIP3SG,NULL,0);break;
	     case IDC_EDIP3NM: percmut        =GetDlgItemInt(w,IDC_EDIP3NM,NULL,0);break;
	     case IDC_EDIP3SE: seed           =GetDlgItemInt(w,IDC_EDIP3SE,NULL,0);break;
	     case IDC_EDIP3SB: delfile        =GetDlgItemInt(w,IDC_EDIP3SB,NULL,0);break;
	     case IDC_EDIP3NR: nreplications  =GetDlgItemInt(w,IDC_EDIP3NR,NULL,0);break;

           }
    }	 
 }

return FALSE;
}



/*
 * Handle the dialog box Parameters->Lifetime
 */

BOOL CALLBACK boxproc4(HWND w,UINT m,WPARAM p1,LPARAM p2)
{


char sbuffer[64];

switch(m)
 {
 case WM_INITDIALOG :
	    SetDlgItemInt(w,IDC_EDIP4NE,amoebaepochs,0);
	    SetDlgItemInt(w,IDC_EDIP4NS,sweeps,0);
	    SetDlgItemInt(w,IDC_EDIP4TL,timelaps,0);
	    SetDlgItemInt(w,IDC_EDIP4SE,save_error_each,0);
	    sprintf(sbuffer,"%.1f",rate);
            SetDlgItemText(w,IDC_EDIP4LR,sbuffer);
	    sprintf(sbuffer,"%.2f",sensornoise);
            SetDlgItemText(w,IDC_EDIP4SN,sbuffer);
	    if (testsamep == 0)
		CheckDlgButton(w,IDC_CHEP4FP,0);
	       else
		CheckDlgButton(w,IDC_CHEP4FP,1);
	    if (nobreak == 0)
		CheckDlgButton(w,IDC_CHEP4NB,0);
	       else
		CheckDlgButton(w,IDC_CHEP4NB,1);
	    if (stop_when_crash == 0)
		CheckDlgButton(w,IDC_CHEP4SC,0);
	       else
		CheckDlgButton(w,IDC_CHEP4SC,1);
	    if (random_sround == 0)
		CheckDlgButton(w,IDC_CHEP4RS,0);
	       else
		CheckDlgButton(w,IDC_CHEP4RS,1);
	    if (random_round == 0)
		CheckDlgButton(w,IDC_CHEP4RR,0);
	       else
		CheckDlgButton(w,IDC_CHEP4RR,1);
	    if (startonfood == 0)
		CheckDlgButton(w,IDC_CHEP4OF,0);
	       else
		CheckDlgButton(w,IDC_CHEP4OF,1);
	    if (startfrontal == 0)
		CheckDlgButton(w,IDC_CHEP4FR,0);
	       else
		CheckDlgButton(w,IDC_CHEP4FR,1);
	    if (startfarfrom == 0)
		CheckDlgButton(w,IDC_CHEP4FF,0);
	       else
		CheckDlgButton(w,IDC_CHEP4FF,1);
	    if (reappears == 0)
		CheckDlgButton(w,IDC_CHEP4TR2,0);
	       else
		CheckDlgButton(w,IDC_CHEP4TR2,1);
	    if (random_foodzone == 0)
		CheckDlgButton(w,IDC_CHEP4XX,0);
	       else
		CheckDlgButton(w,IDC_CHEP4XX,1);
	    if (alternate_wall == 0)
		CheckDlgButton(w,IDC_CHEP4AL,0);
	       else
		CheckDlgButton(w,IDC_CHEP4AL,1);
     break;
 case WM_COMMAND:
    switch(HIWORD(p1))
     { 
        case BN_CLICKED:
	  switch (LOWORD(p1))
	   {
	     case IDOK:
		  EndDialog(w,0);
		  break;
	     case IDC_CHEP4FP:
		 if (testsamep == 0)
		   testsamep = 1;
                  else
		   testsamep = 0;
	         break;
	     case IDC_CHEP4NB:
		 if (nobreak == 0)
		   nobreak = 1;
                  else
		   nobreak = 0;
	         break;
	     case IDC_CHEP4SC:
		 if (stop_when_crash == 0)
		   stop_when_crash = 1;
                  else
		   stop_when_crash = 0;
	         break;
	     case IDC_CHEP4RS:
		 if (random_sround == 0)
		    random_sround = 1;
                  else
		    random_sround = 0;
	         break;
	     case IDC_CHEP4RR:
		 if (random_round == 0)
		    random_round = 1;
                  else
		    random_round = 0;
	         break;
	     case IDC_CHEP4OF:
		 if (startonfood == 0)
		    startonfood = 1;
                  else
		    startonfood = 0;
	         break;
	     case IDC_CHEP4FR:
		 if (startfrontal == 0)
		    startfrontal = 1;
                  else
		    startfrontal = 0;
	         break;
	     case IDC_CHEP4FF:
		 if (startfarfrom == 0)
		    startfarfrom = 1;
                  else
		    startfarfrom = 0;
	         break;
	     case IDC_CHEP4TR2:
		 if (reappears == 0)
		    reappears = 1;
                  else
		    reappears = 0;
	         break;
	     case IDC_CHEP4XX:
		 if (random_foodzone == 0)
		    random_foodzone = 1;
                  else
		    random_foodzone = 0;
	         break;
	     case IDC_CHEP4AL:
		 if (alternate_wall == 0)
		    alternate_wall = 1;
                  else
		    alternate_wall = 0;
	         break;
           }
        case EN_CHANGE:
	  switch (LOWORD(p1))
	   {	 
	     case IDC_EDIP4NE: amoebaepochs    =GetDlgItemInt(w,IDC_EDIP4NE,NULL,0);break;
	     case IDC_EDIP4NS: sweeps          =GetDlgItemInt(w,IDC_EDIP4NS,NULL,0);break;
	     case IDC_EDIP4TL: timelaps        =GetDlgItemInt(w,IDC_EDIP4TL,NULL,0);break;
	     case IDC_EDIP4SE: save_error_each =GetDlgItemInt(w,IDC_EDIP4SE,NULL,0);break;
	     case IDC_EDIP4LR: GetDlgItemText(w,IDC_EDIP4LR,sbuffer,64); sscanf(sbuffer,"%f", &rate);break;
	     case IDC_EDIP4SN: GetDlgItemText(w,IDC_EDIP4SN,sbuffer,64); sscanf(sbuffer,"%f", &sensornoise);break;
           }
	   
    }	 
 }

return FALSE;
}


/*
 * Handle the dialog box Parameters->Display
 */

BOOL CALLBACK boxproc5(HWND w,UINT m,WPARAM p1,LPARAM p2)
{


switch(m)
 {
 case WM_INITDIALOG :
	    SetDlgItemInt(w,IDC_EDIP5TA,timeadjust,0);
	    SetDlgItemInt(w,IDC_EDIP5SC,userscale,0);
	    if (drawindividual == 0)
		CheckDlgButton(w,IDC_CHEP5DI,0);
	       else
		CheckDlgButton(w,IDC_CHEP5DI,1);
	    if (drawtrace == 0)
		CheckDlgButton(w,IDC_CHEP5TR,0);
	       else
		CheckDlgButton(w,IDC_CHEP5TR,1);
	    if (drawindif == 0)
		CheckDlgButton(w,IDC_CHEP5IR,0);
	       else
		CheckDlgButton(w,IDC_CHEP5IR,1);
	    if (drawindlight == 0)
		CheckDlgButton(w,IDC_CHEP5LI,0);
	       else
		CheckDlgButton(w,IDC_CHEP5LI,1);
	    if (drawcamera == 0)
		CheckDlgButton(w,IDC_CHEP5CA,0);
	       else
		CheckDlgButton(w,IDC_CHEP5CA,1);
	    if (graphsensors == 0)
		CheckDlgButton(w,IDC_CHEP5DS,0);
	       else
		CheckDlgButton(w,IDC_CHEP5DS,1);
	    if (drawinputs == 0)
		CheckDlgButton(w,IDC_CHEP5IN,0);
	       else
		CheckDlgButton(w,IDC_CHEP5IN,1);
	    if (drawoutputs == 0)
		CheckDlgButton(w,IDC_CHEP5OU,0);
	       else
		CheckDlgButton(w,IDC_CHEP5OU,1);
	    if (drawhiddens == 0)
		CheckDlgButton(w,IDC_CHEP5HI,0);
	       else
		CheckDlgButton(w,IDC_CHEP5HI,1);
	    if (drawfitness == 0)
		CheckDlgButton(w,IDC_CHEP5FI,0);
	       else
		CheckDlgButton(w,IDC_CHEP5FI,1);
	    if (drawerror == 0)
		CheckDlgButton(w,IDC_CHEP5ER,0);
	       else
		CheckDlgButton(w,IDC_CHEP5ER,1);
	    if (drawperceived == 0)
		CheckDlgButton(w,IDC_CHEP5PE,0);
	       else
		CheckDlgButton(w,IDC_CHEP5PE,1);
	    if (drawteaching == 0)
		CheckDlgButton(w,IDC_CHEP5TE,0);
	       else
		CheckDlgButton(w,IDC_CHEP5TE,1);
	    if (drawselfselmaps == 0)
		CheckDlgButton(w,IDC_CHEP5RP,0);
	       else
		CheckDlgButton(w,IDC_CHEP5RP,1);
	    if (drawallepochs == 0)
		CheckDlgButton(w,IDC_CHEP5AE,0);
	       else
		CheckDlgButton(w,IDC_CHEP5AE,1);
	    if (drawallpopulation == 0)
		CheckDlgButton(w,IDC_CHEP5AP,0);
	       else
		CheckDlgButton(w,IDC_CHEP5AP,1);
	    if (black_and_white == 0)
		CheckDlgButton(w,IDC_CHEP5BW,0);
	       else
		CheckDlgButton(w,IDC_CHEP5BW,1);
	    if (drawdata == 0)
		CheckDlgButton(w,IDC_CHEP5DD,0);
	       else
		CheckDlgButton(w,IDC_CHEP5DD,1);
	    if (draweights == 0)
		CheckDlgButton(w,IDC_CHEP5DW,0);
	       else
		CheckDlgButton(w,IDC_CHEP5DW,1);
 case WM_COMMAND:
    switch(HIWORD(p1))
     { 
        case BN_CLICKED:
	  switch (LOWORD(p1))
	   {
	     case IDOK:
		  EndDialog(w,0);
		  break;
	     case IDC_CHEP5DI:
		 if (drawindividual == 0)
		  {
		   if (run_evolution == 0)
		     drawindividual = 1;
                   if (run_evolution == 1 && sim_real == 0)
		    {
                      if (graphsensors == 0 && draweights == 0 && drawselfselmaps == 0) 
	               {
	                 if (drawallpopulation == 0)
	                   set_scale(env[cworld].dx,env[cworld].dy);	     
	                  else
	                   set_scale(env[cworld].dx*10,env[cworld].dy*10);
			 drawindividual = 1;
		       }
		       else
		       {
                         if (drawallpopulation == 0 && drawallepochs == 0)
			 {
	                   set_scale(env[cworld].dx*3,env[cworld].dy);
	                   wendx = (int) (env[cworld].dx * scale) + (startx * 2);
			   drawindividual = 1;
			 }
		       }
		    }
		   }
                  else
		   {
		    drawindividual = 0;
		   }
	         break;
	     case IDC_CHEP5TR:
		 if (drawtrace == 0)
		   drawtrace = 1;
                  else
		   drawtrace = 0;
	         break;
	     case IDC_CHEP5IR:
		 if (drawindif == 0)
		   drawindif = 1;
                  else
		   drawindif = 0;
	         break;
	     case IDC_CHEP5LI:
		 if (drawindlight == 0)
		   drawindlight = 1;
                  else
		   drawindlight = 0;
	         break;
	     case IDC_CHEP5CA:
		 if (drawcamera == 0)
		   drawcamera = 1;
                  else
		   drawcamera = 0;
	         break;
	     case IDC_CHEP5DS:
		 if (graphsensors == 0)
		   graphsensors = 1;
                  else
		   graphsensors = 0;
	         break;
	     case IDC_CHEP5IN:
		 if (drawinputs == 0)
		   drawinputs = 1;
                  else
		   drawinputs = 0;
	         break;
	     case IDC_CHEP5OU:
		 if (drawoutputs == 0)
		   drawoutputs = 1;
                  else
		   drawoutputs = 0;
	         break;
	     case IDC_CHEP5HI:
		 if (drawhiddens == 0)
		   drawhiddens = 1;
                  else
		   drawhiddens = 0;
	         break;
	     case IDC_CHEP5FI:
		 if (drawfitness == 0)
		   drawfitness = 1;
                  else
		   drawfitness = 0;
	         break;
	     case IDC_CHEP5ER:
		 if (drawerror == 0)
		   drawerror = 1;
                  else
		   drawerror = 0;
	         break;
	     case IDC_CHEP5PE:
		 if (drawperceived == 0)
		   drawperceived = 1;
                  else
		   drawperceived = 0;
	         break;
	     case IDC_CHEP5TE:
		 if (drawteaching == 0)
		   drawteaching = 1;
                  else
		   drawteaching = 0;
	         break;
	     case IDC_CHEP5RP:
		 if (drawselfselmaps == 0)
		   drawselfselmaps = 1;
                  else
		   drawselfselmaps = 0;
	         break;
	     case IDC_CHEP5AE:
		 if (drawallepochs == 0)
		   drawallepochs = 1;
                  else
		   drawallepochs = 0;
	         break;
	     case IDC_CHEP5AP:
		 if (drawallpopulation == 0)
		   drawallpopulation = 1;
                  else
		   drawallpopulation = 0;
	         break;
	     case IDC_CHEP5BW:
		 if (black_and_white == 0)
		   black_and_white = 1;
                  else
		   black_and_white = 0;
	         break;
	     case IDC_CHEP5DD:
		 if (drawdata == 0)
		   drawdata = 1;
                  else
		   drawdata = 0;
	         break;
	     case IDC_CHEP5DW:
		 if (draweights == 0)
		   draweights = 1;
                  else
		   draweights = 0;
	         break;
           }
        case EN_CHANGE:
	  switch (LOWORD(p1))
	   {	 
	     case IDC_EDIP5TA: timeadjust =GetDlgItemInt(w,IDC_EDIP5TA,NULL,0);break;
	     case IDC_EDIP5SC: userscale  =GetDlgItemInt(w,IDC_EDIP5SC,NULL,0);break;
           }
	   
    }	 
 }

return FALSE;
}



/*
 * handle the dialog box Parameters->environment
 */


BOOL CALLBACK boxproc6(HWND w,UINT m,WPARAM p1,LPARAM p2)

{

   char   sbuffer[64];
   int i;


 switch(m)
 {
    case WM_INITDIALOG:
       SetDlgItemInt(w,IDC_EDIP6CW,cworld,0);
       SetDlgItemInt(w,IDC_EDIP6NE,nworlds,0);
       SetDlgItemInt(w,IDC_EDIP6NW,env[cworld].nobstacles,0);
       SetDlgItemInt(w,IDC_EDIP6NR,env[cworld].nroundobst,0);
       SetDlgItemInt(w,IDC_EDIP6NS,env[cworld].nsroundobst,0);
       SetDlgItemInt(w,IDC_EDIP6NT,env[cworld].nfoodzones,0);
       SetDlgItemInt(w,IDC_EDIP6NL,env[cworld].nbulblights,0);
       SetDlgItemInt(w,IDC_EDIP6NP,env[cworld].nstarts,0);
       sprintf(sbuffer,"%.1f",env[cworld].radius);
       SetDlgItemText(w,IDC_EDIP6NRR,sbuffer);
       sprintf(sbuffer,"%.1f",env[cworld].sradius);
       SetDlgItemText(w,IDC_EDIP6NSR,sbuffer);
       SetDlgItemText(w,IDC_EDIP6FN,worldfiles);

       SetDlgItemInt(w,IDC_EDIP6WA1,(int) env[cworld].obstacles[0][0],0);
       SetDlgItemInt(w,IDC_EDIP6WA2,(int) env[cworld].obstacles[0][1],0);
       SetDlgItemInt(w,IDC_EDIP6WA3,(int) env[cworld].obstacles[0][2],0);
       SetDlgItemInt(w,IDC_EDIP6WA4,(int) env[cworld].obstacles[0][3],0);
       SetDlgItemInt(w,IDC_EDIP6WB1,(int) env[cworld].obstacles[1][0],0);
       SetDlgItemInt(w,IDC_EDIP6WB2,(int) env[cworld].obstacles[1][1],0);
       SetDlgItemInt(w,IDC_EDIP6WB3,(int) env[cworld].obstacles[1][2],0);
       SetDlgItemInt(w,IDC_EDIP6WB4,(int) env[cworld].obstacles[1][3],0);
       SetDlgItemInt(w,IDC_EDIP6WC1,(int) env[cworld].obstacles[2][0],0);
       SetDlgItemInt(w,IDC_EDIP6WC2,(int) env[cworld].obstacles[2][1],0);
       SetDlgItemInt(w,IDC_EDIP6WC3,(int) env[cworld].obstacles[2][2],0);
       SetDlgItemInt(w,IDC_EDIP6WC4,(int) env[cworld].obstacles[2][3],0);
       SetDlgItemInt(w,IDC_EDIP6WD1,(int) env[cworld].obstacles[3][0],0);
       SetDlgItemInt(w,IDC_EDIP6WD2,(int) env[cworld].obstacles[3][1],0);
       SetDlgItemInt(w,IDC_EDIP6WD3,(int) env[cworld].obstacles[3][2],0);
       SetDlgItemInt(w,IDC_EDIP6WD4,(int) env[cworld].obstacles[3][3],0);
       SetDlgItemInt(w,IDC_EDIP6WE1,(int) env[cworld].obstacles[4][0],0);
       SetDlgItemInt(w,IDC_EDIP6WE2,(int) env[cworld].obstacles[4][1],0);
       SetDlgItemInt(w,IDC_EDIP6WE3,(int) env[cworld].obstacles[4][2],0);
       SetDlgItemInt(w,IDC_EDIP6WE4,(int) env[cworld].obstacles[4][3],0);
       SetDlgItemInt(w,IDC_EDIP6WF1,(int) env[cworld].obstacles[5][0],0);
       SetDlgItemInt(w,IDC_EDIP6WF2,(int) env[cworld].obstacles[5][1],0);
       SetDlgItemInt(w,IDC_EDIP6WF3,(int) env[cworld].obstacles[5][2],0);
       SetDlgItemInt(w,IDC_EDIP6WF4,(int) env[cworld].obstacles[5][3],0);
       SetDlgItemInt(w,IDC_EDIP6WG1,(int) env[cworld].obstacles[6][0],0);
       SetDlgItemInt(w,IDC_EDIP6WG2,(int) env[cworld].obstacles[6][1],0);
       SetDlgItemInt(w,IDC_EDIP6WG3,(int) env[cworld].obstacles[6][2],0);
       SetDlgItemInt(w,IDC_EDIP6WG4,(int) env[cworld].obstacles[6][3],0);
       SetDlgItemInt(w,IDC_EDIP6WH1,(int) env[cworld].obstacles[7][0],0);
       SetDlgItemInt(w,IDC_EDIP6WH2,(int) env[cworld].obstacles[7][1],0);
       SetDlgItemInt(w,IDC_EDIP6WH3,(int) env[cworld].obstacles[7][2],0);
       SetDlgItemInt(w,IDC_EDIP6WH4,(int) env[cworld].obstacles[7][3],0);

       SetDlgItemInt(w,IDC_EDIP6RA1,(int) env[cworld].roundobst[0][0],0);
       SetDlgItemInt(w,IDC_EDIP6RA2,(int) env[cworld].roundobst[0][1],0);
       SetDlgItemInt(w,IDC_EDIP6RB1,(int) env[cworld].roundobst[1][0],0);
       SetDlgItemInt(w,IDC_EDIP6RB2,(int) env[cworld].roundobst[1][1],0);
       SetDlgItemInt(w,IDC_EDIP6RC1,(int) env[cworld].roundobst[2][0],0);
       SetDlgItemInt(w,IDC_EDIP6RC2,(int) env[cworld].roundobst[2][1],0);
       SetDlgItemInt(w,IDC_EDIP6RD1,(int) env[cworld].roundobst[3][0],0);
       SetDlgItemInt(w,IDC_EDIP6RD2,(int) env[cworld].roundobst[3][1],0);
       SetDlgItemInt(w,IDC_EDIP6RE1,(int) env[cworld].roundobst[4][0],0);
       SetDlgItemInt(w,IDC_EDIP6RE2,(int) env[cworld].roundobst[4][1],0);
       SetDlgItemInt(w,IDC_EDIP6RF1,(int) env[cworld].roundobst[5][0],0);
       SetDlgItemInt(w,IDC_EDIP6RF2,(int) env[cworld].roundobst[5][1],0);
       SetDlgItemInt(w,IDC_EDIP6RG1,(int) env[cworld].roundobst[6][0],0);
       SetDlgItemInt(w,IDC_EDIP6RG2,(int) env[cworld].roundobst[6][1],0);
       SetDlgItemInt(w,IDC_EDIP6RH1,(int) env[cworld].roundobst[7][0],0);
       SetDlgItemInt(w,IDC_EDIP6RH2,(int) env[cworld].roundobst[7][1],0);

       SetDlgItemInt(w,IDC_EDIP6SA1,(int) env[cworld].sroundobst[0][0],0);
       SetDlgItemInt(w,IDC_EDIP6SA2,(int) env[cworld].sroundobst[0][1],0);
       SetDlgItemInt(w,IDC_EDIP6SB1,(int) env[cworld].sroundobst[1][0],0);
       SetDlgItemInt(w,IDC_EDIP6SB2,(int) env[cworld].sroundobst[1][1],0);
       SetDlgItemInt(w,IDC_EDIP6SC1,(int) env[cworld].sroundobst[2][0],0);
       SetDlgItemInt(w,IDC_EDIP6SC2,(int) env[cworld].sroundobst[2][1],0);
       SetDlgItemInt(w,IDC_EDIP6SD1,(int) env[cworld].sroundobst[3][0],0);
       SetDlgItemInt(w,IDC_EDIP6SD2,(int) env[cworld].sroundobst[3][1],0);
       SetDlgItemInt(w,IDC_EDIP6SE1,(int) env[cworld].sroundobst[4][0],0);
       SetDlgItemInt(w,IDC_EDIP6SE2,(int) env[cworld].sroundobst[4][1],0);
       SetDlgItemInt(w,IDC_EDIP6SF1,(int) env[cworld].sroundobst[5][0],0);
       SetDlgItemInt(w,IDC_EDIP6SF2,(int) env[cworld].sroundobst[5][1],0);
       SetDlgItemInt(w,IDC_EDIP6SG1,(int) env[cworld].sroundobst[6][0],0);
       SetDlgItemInt(w,IDC_EDIP6SG2,(int) env[cworld].sroundobst[6][1],0);
       SetDlgItemInt(w,IDC_EDIP6SH1,(int) env[cworld].sroundobst[7][0],0);
       SetDlgItemInt(w,IDC_EDIP6SH2,(int) env[cworld].sroundobst[7][1],0);

       SetDlgItemInt(w,IDC_EDIP6TA1,(int) env[cworld].foodzones[0][0],0);
       SetDlgItemInt(w,IDC_EDIP6TA2,(int) env[cworld].foodzones[0][1],0);
       SetDlgItemInt(w,IDC_EDIP6TA3,(int) env[cworld].foodzones[0][2],0);
       SetDlgItemInt(w,IDC_EDIP6TB1,(int) env[cworld].foodzones[1][0],0);
       SetDlgItemInt(w,IDC_EDIP6TB2,(int) env[cworld].foodzones[1][1],0);
       SetDlgItemInt(w,IDC_EDIP6TB3,(int) env[cworld].foodzones[1][2],0);
       SetDlgItemInt(w,IDC_EDIP6TC1,(int) env[cworld].foodzones[2][0],0);
       SetDlgItemInt(w,IDC_EDIP6TC2,(int) env[cworld].foodzones[2][1],0);
       SetDlgItemInt(w,IDC_EDIP6TC3,(int) env[cworld].foodzones[2][2],0);
       SetDlgItemInt(w,IDC_EDIP6TD1,(int) env[cworld].foodzones[3][0],0);
       SetDlgItemInt(w,IDC_EDIP6TD2,(int) env[cworld].foodzones[3][1],0);
       SetDlgItemInt(w,IDC_EDIP6TD3,(int) env[cworld].foodzones[3][2],0);

       SetDlgItemInt(w,IDC_EDIP6LA1,(int) env[cworld].bulblights[0][0],0);
       SetDlgItemInt(w,IDC_EDIP6LA2,(int) env[cworld].bulblights[0][1],0);
       SetDlgItemInt(w,IDC_EDIP6LB1,(int) env[cworld].bulblights[1][0],0);
       SetDlgItemInt(w,IDC_EDIP6LB2,(int) env[cworld].bulblights[1][1],0);
       SetDlgItemInt(w,IDC_EDIP6LC1,(int) env[cworld].bulblights[2][0],0);
       SetDlgItemInt(w,IDC_EDIP6LC2,(int) env[cworld].bulblights[2][1],0);
       SetDlgItemInt(w,IDC_EDIP6LD1,(int) env[cworld].bulblights[3][0],0);
       SetDlgItemInt(w,IDC_EDIP6LD2,(int) env[cworld].bulblights[3][1],0);

       SetDlgItemInt(w,IDC_EDIP6PA1,(int) env[cworld].starts[0][0],0);
       SetDlgItemInt(w,IDC_EDIP6PA2,(int) env[cworld].starts[0][1],0);
       SetDlgItemInt(w,IDC_EDIP6PA3,(int) env[cworld].starts[0][2],0);
       SetDlgItemInt(w,IDC_EDIP6PB1,(int) env[cworld].starts[1][0],0);
       SetDlgItemInt(w,IDC_EDIP6PB2,(int) env[cworld].starts[1][1],0);
       SetDlgItemInt(w,IDC_EDIP6PB3,(int) env[cworld].starts[1][2],0);
       SetDlgItemInt(w,IDC_EDIP6PC1,(int) env[cworld].starts[2][0],0);
       SetDlgItemInt(w,IDC_EDIP6PC2,(int) env[cworld].starts[2][1],0);
       SetDlgItemInt(w,IDC_EDIP6PC3,(int) env[cworld].starts[2][2],0);
       SetDlgItemInt(w,IDC_EDIP6PD1,(int) env[cworld].starts[3][0],0);
       SetDlgItemInt(w,IDC_EDIP6PD2,(int) env[cworld].starts[3][1],0);
       SetDlgItemInt(w,IDC_EDIP6PD3,(int) env[cworld].starts[3][2],0);
       SetDlgItemInt(w,IDC_EDIP6PE1,(int) env[cworld].starts[4][0],0);
       SetDlgItemInt(w,IDC_EDIP6PE2,(int) env[cworld].starts[4][1],0);
       SetDlgItemInt(w,IDC_EDIP6PE3,(int) env[cworld].starts[4][2],0);
       SetDlgItemInt(w,IDC_EDIP6PF1,(int) env[cworld].starts[5][0],0);
       SetDlgItemInt(w,IDC_EDIP6PF2,(int) env[cworld].starts[5][1],0);
       SetDlgItemInt(w,IDC_EDIP6PF3,(int) env[cworld].starts[5][2],0);
       SetDlgItemInt(w,IDC_EDIP6PG1,(int) env[cworld].starts[6][0],0);
       SetDlgItemInt(w,IDC_EDIP6PG2,(int) env[cworld].starts[6][1],0);
       SetDlgItemInt(w,IDC_EDIP6PG3,(int) env[cworld].starts[6][2],0);
       SetDlgItemInt(w,IDC_EDIP6PH1,(int) env[cworld].starts[7][0],0);
       SetDlgItemInt(w,IDC_EDIP6PH2,(int) env[cworld].starts[7][1],0);
       SetDlgItemInt(w,IDC_EDIP6PH3,(int) env[cworld].starts[7][2],0);

       break;

    case WM_COMMAND:
    switch(HIWORD(p1))
     { 
        case BN_CLICKED:
	  switch (LOWORD(p1))
	   {
	     case IDOK:
	     // we compute the dx and dy before exit
	        env[cworld].dx = 0;
	        env[cworld].dy = 0;
                for (i=0; i < env[cworld].nobstacles; i++)
                  { 
                   if (env[cworld].obstacles[i][0] > env[cworld].dx)
                     env[cworld].dx = (int) env[cworld].obstacles[i][0];
                   if (env[cworld].obstacles[i][2] > env[cworld].dx)
                     env[cworld].dx = (int) env[cworld].obstacles[i][2];
                   if (env[cworld].obstacles[i][1] > env[cworld].dy)
                     env[cworld].dy = (int) env[cworld].obstacles[i][1];
                   if (env[cworld].obstacles[i][3] > env[cworld].dy)
                     env[cworld].dy = (int) env[cworld].obstacles[i][3];
                   }
		  EndDialog(w,0);
		  break;
	     case IDSAVE:
		  save_world();
		  break;
           }
        case EN_CHANGE:
	  switch (LOWORD(p1))
	   {
	     // we redisplay all variable when we change environment
	     case IDC_EDIP6CW: 
		     cworld = GetDlgItemInt(w,IDC_EDIP6CW,NULL,0);
		     if (cworld >= 5)
		      {
			display_warning("number of world cannot exceed 5");
			cworld = 4;
			SetDlgItemInt(w,IDC_EDIP6CW,cworld,0);
		      }
		         SetDlgItemInt(w,IDC_EDIP6NW,env[cworld].nobstacles,0);
                         SetDlgItemInt(w,IDC_EDIP6NR,env[cworld].nroundobst,0);
                         SetDlgItemInt(w,IDC_EDIP6NS,env[cworld].nsroundobst,0);
                         SetDlgItemInt(w,IDC_EDIP6NT,env[cworld].nfoodzones,0);
                         SetDlgItemInt(w,IDC_EDIP6NL,env[cworld].nbulblights,0);
                         SetDlgItemInt(w,IDC_EDIP6NP,env[cworld].nstarts,0);
                         sprintf(sbuffer,"%.1f",env[cworld].radius);
                         SetDlgItemText(w,IDC_EDIP6NRR,sbuffer);
                         sprintf(sbuffer,"%.1f",env[cworld].sradius);
                         SetDlgItemText(w,IDC_EDIP6NSR,sbuffer);
                         
                         SetDlgItemInt(w,IDC_EDIP6WA1,(int) env[cworld].obstacles[0][0],0);
                         SetDlgItemInt(w,IDC_EDIP6WA2,(int) env[cworld].obstacles[0][1],0);
                         SetDlgItemInt(w,IDC_EDIP6WA3,(int) env[cworld].obstacles[0][2],0);
                         SetDlgItemInt(w,IDC_EDIP6WA4,(int) env[cworld].obstacles[0][3],0);
                         SetDlgItemInt(w,IDC_EDIP6WB1,(int) env[cworld].obstacles[1][0],0);
                         SetDlgItemInt(w,IDC_EDIP6WB2,(int) env[cworld].obstacles[1][1],0);
                         SetDlgItemInt(w,IDC_EDIP6WB3,(int) env[cworld].obstacles[1][2],0);
                         SetDlgItemInt(w,IDC_EDIP6WB4,(int) env[cworld].obstacles[1][3],0);
                         SetDlgItemInt(w,IDC_EDIP6WC1,(int) env[cworld].obstacles[2][0],0);
                         SetDlgItemInt(w,IDC_EDIP6WC2,(int) env[cworld].obstacles[2][1],0);
                         SetDlgItemInt(w,IDC_EDIP6WC3,(int) env[cworld].obstacles[2][2],0);
                         SetDlgItemInt(w,IDC_EDIP6WC4,(int) env[cworld].obstacles[2][3],0);
                         SetDlgItemInt(w,IDC_EDIP6WD1,(int) env[cworld].obstacles[3][0],0);
                         SetDlgItemInt(w,IDC_EDIP6WD2,(int) env[cworld].obstacles[3][1],0);
                         SetDlgItemInt(w,IDC_EDIP6WD3,(int) env[cworld].obstacles[3][2],0);
                         SetDlgItemInt(w,IDC_EDIP6WD4,(int) env[cworld].obstacles[3][3],0);
                         SetDlgItemInt(w,IDC_EDIP6WE1,(int) env[cworld].obstacles[4][0],0);
                         SetDlgItemInt(w,IDC_EDIP6WE2,(int) env[cworld].obstacles[4][1],0);
                         SetDlgItemInt(w,IDC_EDIP6WE3,(int) env[cworld].obstacles[4][2],0);
                         SetDlgItemInt(w,IDC_EDIP6WE4,(int) env[cworld].obstacles[4][3],0);
                         SetDlgItemInt(w,IDC_EDIP6WF1,(int) env[cworld].obstacles[5][0],0);
                         SetDlgItemInt(w,IDC_EDIP6WF2,(int) env[cworld].obstacles[5][1],0);
                         SetDlgItemInt(w,IDC_EDIP6WF3,(int) env[cworld].obstacles[5][2],0);
                         SetDlgItemInt(w,IDC_EDIP6WF4,(int) env[cworld].obstacles[5][3],0);
                         SetDlgItemInt(w,IDC_EDIP6WG1,(int) env[cworld].obstacles[6][0],0);
                         SetDlgItemInt(w,IDC_EDIP6WG2,(int) env[cworld].obstacles[6][1],0);
                         SetDlgItemInt(w,IDC_EDIP6WG3,(int) env[cworld].obstacles[6][2],0);
                         SetDlgItemInt(w,IDC_EDIP6WG4,(int) env[cworld].obstacles[6][3],0);
                         SetDlgItemInt(w,IDC_EDIP6WH1,(int) env[cworld].obstacles[7][0],0);
                         SetDlgItemInt(w,IDC_EDIP6WH2,(int) env[cworld].obstacles[7][1],0);
                         SetDlgItemInt(w,IDC_EDIP6WH3,(int) env[cworld].obstacles[7][2],0);
                         SetDlgItemInt(w,IDC_EDIP6WH4,(int) env[cworld].obstacles[7][3],0);

                         SetDlgItemInt(w,IDC_EDIP6RA1,(int) env[cworld].roundobst[0][0],0);
                         SetDlgItemInt(w,IDC_EDIP6RA2,(int) env[cworld].roundobst[0][1],0);
                         SetDlgItemInt(w,IDC_EDIP6RB1,(int) env[cworld].roundobst[1][0],0);
                         SetDlgItemInt(w,IDC_EDIP6RB2,(int) env[cworld].roundobst[1][1],0);
                         SetDlgItemInt(w,IDC_EDIP6RC1,(int) env[cworld].roundobst[2][0],0);
                         SetDlgItemInt(w,IDC_EDIP6RC2,(int) env[cworld].roundobst[2][1],0);
                         SetDlgItemInt(w,IDC_EDIP6RD1,(int) env[cworld].roundobst[3][0],0);
                         SetDlgItemInt(w,IDC_EDIP6RD2,(int) env[cworld].roundobst[3][1],0);
                         SetDlgItemInt(w,IDC_EDIP6RE1,(int) env[cworld].roundobst[4][0],0);
                         SetDlgItemInt(w,IDC_EDIP6RE2,(int) env[cworld].roundobst[4][1],0);
                         SetDlgItemInt(w,IDC_EDIP6RF1,(int) env[cworld].roundobst[5][0],0);
                         SetDlgItemInt(w,IDC_EDIP6RF2,(int) env[cworld].roundobst[5][1],0);
                         SetDlgItemInt(w,IDC_EDIP6RG1,(int) env[cworld].roundobst[6][0],0);
                         SetDlgItemInt(w,IDC_EDIP6RG2,(int) env[cworld].roundobst[6][1],0);
                         SetDlgItemInt(w,IDC_EDIP6RH1,(int) env[cworld].roundobst[7][0],0);
                         SetDlgItemInt(w,IDC_EDIP6RH2,(int) env[cworld].roundobst[7][1],0);

                         SetDlgItemInt(w,IDC_EDIP6SA1,(int) env[cworld].sroundobst[0][0],0);
                         SetDlgItemInt(w,IDC_EDIP6SA2,(int) env[cworld].sroundobst[0][1],0);
                         SetDlgItemInt(w,IDC_EDIP6SB1,(int) env[cworld].sroundobst[1][0],0);
                         SetDlgItemInt(w,IDC_EDIP6SB2,(int) env[cworld].sroundobst[1][1],0);
                         SetDlgItemInt(w,IDC_EDIP6SC1,(int) env[cworld].sroundobst[2][0],0);
                         SetDlgItemInt(w,IDC_EDIP6SC2,(int) env[cworld].sroundobst[2][1],0);
                         SetDlgItemInt(w,IDC_EDIP6SD1,(int) env[cworld].sroundobst[3][0],0);
                         SetDlgItemInt(w,IDC_EDIP6SD2,(int) env[cworld].sroundobst[3][1],0);
                         SetDlgItemInt(w,IDC_EDIP6SE1,(int) env[cworld].sroundobst[4][0],0);
                         SetDlgItemInt(w,IDC_EDIP6SE2,(int) env[cworld].sroundobst[4][1],0);
                         SetDlgItemInt(w,IDC_EDIP6SF1,(int) env[cworld].sroundobst[5][0],0);
                         SetDlgItemInt(w,IDC_EDIP6SF2,(int) env[cworld].sroundobst[5][1],0);
                         SetDlgItemInt(w,IDC_EDIP6SG1,(int) env[cworld].sroundobst[6][0],0);
                         SetDlgItemInt(w,IDC_EDIP6SG2,(int) env[cworld].sroundobst[6][1],0);
                         SetDlgItemInt(w,IDC_EDIP6SH1,(int) env[cworld].sroundobst[7][0],0);
                         SetDlgItemInt(w,IDC_EDIP6SH2,(int) env[cworld].sroundobst[7][1],0);

                         SetDlgItemInt(w,IDC_EDIP6TA1,(int) env[cworld].foodzones[0][0],0);
                         SetDlgItemInt(w,IDC_EDIP6TA2,(int) env[cworld].foodzones[0][1],0);
                         SetDlgItemInt(w,IDC_EDIP6TA3,(int) env[cworld].foodzones[0][2],0);
                         SetDlgItemInt(w,IDC_EDIP6TB1,(int) env[cworld].foodzones[1][0],0);
                         SetDlgItemInt(w,IDC_EDIP6TB2,(int) env[cworld].foodzones[1][1],0);
                         SetDlgItemInt(w,IDC_EDIP6TB3,(int) env[cworld].foodzones[1][2],0);
                         SetDlgItemInt(w,IDC_EDIP6TC1,(int) env[cworld].foodzones[2][0],0);
                         SetDlgItemInt(w,IDC_EDIP6TC2,(int) env[cworld].foodzones[2][1],0);
                         SetDlgItemInt(w,IDC_EDIP6TC3,(int) env[cworld].foodzones[2][2],0);
                         SetDlgItemInt(w,IDC_EDIP6TD1,(int) env[cworld].foodzones[3][0],0);
                         SetDlgItemInt(w,IDC_EDIP6TD2,(int) env[cworld].foodzones[3][1],0);
                         SetDlgItemInt(w,IDC_EDIP6TD3,(int) env[cworld].foodzones[3][2],0);

                         SetDlgItemInt(w,IDC_EDIP6LA1,(int) env[cworld].bulblights[0][0],0);
                         SetDlgItemInt(w,IDC_EDIP6LA2,(int) env[cworld].bulblights[0][1],0);
                         SetDlgItemInt(w,IDC_EDIP6LB1,(int) env[cworld].bulblights[1][0],0);
                         SetDlgItemInt(w,IDC_EDIP6LB2,(int) env[cworld].bulblights[1][1],0);
                         SetDlgItemInt(w,IDC_EDIP6LC1,(int) env[cworld].bulblights[2][0],0);
                         SetDlgItemInt(w,IDC_EDIP6LC2,(int) env[cworld].bulblights[2][1],0);
                         SetDlgItemInt(w,IDC_EDIP6LD1,(int) env[cworld].bulblights[3][0],0);
                         SetDlgItemInt(w,IDC_EDIP6LD2,(int) env[cworld].bulblights[3][1],0);

                         SetDlgItemInt(w,IDC_EDIP6PA1,(int) env[cworld].starts[0][0],0);
                         SetDlgItemInt(w,IDC_EDIP6PA2,(int) env[cworld].starts[0][1],0);
                         SetDlgItemInt(w,IDC_EDIP6PA3,(int) env[cworld].starts[0][2],0);
                         SetDlgItemInt(w,IDC_EDIP6PB1,(int) env[cworld].starts[1][0],0);
                         SetDlgItemInt(w,IDC_EDIP6PB2,(int) env[cworld].starts[1][1],0);
                         SetDlgItemInt(w,IDC_EDIP6PB3,(int) env[cworld].starts[1][2],0);
                         SetDlgItemInt(w,IDC_EDIP6PC1,(int) env[cworld].starts[2][0],0);
                         SetDlgItemInt(w,IDC_EDIP6PC2,(int) env[cworld].starts[2][1],0);
                         SetDlgItemInt(w,IDC_EDIP6PC3,(int) env[cworld].starts[2][2],0);
                         SetDlgItemInt(w,IDC_EDIP6PD1,(int) env[cworld].starts[3][0],0);
                         SetDlgItemInt(w,IDC_EDIP6PD2,(int) env[cworld].starts[3][1],0);
                         SetDlgItemInt(w,IDC_EDIP6PD3,(int) env[cworld].starts[3][2],0);
                         SetDlgItemInt(w,IDC_EDIP6PE1,(int) env[cworld].starts[4][0],0);
                         SetDlgItemInt(w,IDC_EDIP6PE2,(int) env[cworld].starts[4][1],0);
                         SetDlgItemInt(w,IDC_EDIP6PE3,(int) env[cworld].starts[4][2],0);
                         SetDlgItemInt(w,IDC_EDIP6PF1,(int) env[cworld].starts[5][0],0);
                         SetDlgItemInt(w,IDC_EDIP6PF2,(int) env[cworld].starts[5][1],0);
                         SetDlgItemInt(w,IDC_EDIP6PF3,(int) env[cworld].starts[5][2],0);
                         SetDlgItemInt(w,IDC_EDIP6PG1,(int) env[cworld].starts[6][0],0);
                         SetDlgItemInt(w,IDC_EDIP6PG2,(int) env[cworld].starts[6][1],0);
                         SetDlgItemInt(w,IDC_EDIP6PG3,(int) env[cworld].starts[6][2],0);
                         SetDlgItemInt(w,IDC_EDIP6PH1,(int) env[cworld].starts[7][0],0);
                         SetDlgItemInt(w,IDC_EDIP6PH2,(int) env[cworld].starts[7][1],0);
                         SetDlgItemInt(w,IDC_EDIP6PH3,(int) env[cworld].starts[7][2],0);
		     break;
	     case IDC_EDIP6NE: 
		     nworlds = GetDlgItemInt(w,IDC_EDIP6NE,NULL,0);
		     if (cworld >= 5)
		      {
			display_warning("number of world cannot exceed 5");
			nworlds = 4;
			SetDlgItemInt(w,IDC_EDIP6NE,nworlds,0);
		      }
		     break;			     
	     case IDC_EDIP6NW: 
		     env[cworld].nobstacles = GetDlgItemInt(w,IDC_EDIP6NW,NULL,0);
		     if (env[cworld].nobstacles >= 20)
		      {
			display_warning("number of walls cannot exceed 20");
			env[cworld].nobstacles = 19;
			SetDlgItemInt(w,IDC_EDIP6NW,env[cworld].nobstacles,0);
		      }
		     break;
	     case IDC_EDIP6NR: 
		     env[cworld].nroundobst = GetDlgItemInt(w,IDC_EDIP6NR,NULL,0);
		     if (env[cworld].nroundobst >= 20)
		      {
			display_warning("number of round obstacles cannot exceed 20");
			env[cworld].nroundobst = 19;
			SetDlgItemInt(w,IDC_EDIP6NR,env[cworld].nroundobst,0);
		      }
		     break;
	     case IDC_EDIP6NS: 
		     env[cworld].nsroundobst = GetDlgItemInt(w,IDC_EDIP6NS,NULL,0);
		     if (env[cworld].nsroundobst >= 20)
		      {
			display_warning("number of small round obstacles cannot exceed 20");
			env[cworld].nsroundobst = 19;
			SetDlgItemInt(w,IDC_EDIP6NW,env[cworld].nsroundobst,0);
		      }
		     break;
	     case IDC_EDIP6NL: 
		     env[cworld].nbulblights = GetDlgItemInt(w,IDC_EDIP6NL,NULL,0);
		     if (env[cworld].nbulblights >= 20)
		      {
			display_warning("number of lights cannot exceed 20");
			env[cworld].nbulblights = 19;
			SetDlgItemInt(w,IDC_EDIP6NL,env[cworld].nbulblights,0);
		      }
		     break;
	     case IDC_EDIP6NT: 
		     env[cworld].nfoodzones = GetDlgItemInt(w,IDC_EDIP6NT,NULL,0);
		     if (env[cworld].nfoodzones >= 20)
		      {
			display_warning("number of target areas cannot exceed 20");
			env[cworld].nfoodzones = 19;
			SetDlgItemInt(w,IDC_EDIP6NT,env[cworld].nfoodzones,0);
		      }
		     break;
	     case IDC_EDIP6NP: 
		     env[cworld].nstarts = GetDlgItemInt(w,IDC_EDIP6NP,NULL,0);
		     if (env[cworld].nstarts >= 50)
		      {
			display_warning("number of starting positions cannot exceed 50");
			env[cworld].nstarts = 49;
			SetDlgItemInt(w,IDC_EDIP6NP,env[cworld].nstarts,0);
		      }
		     break;
	     case IDC_EDIP6NRR: GetDlgItemText(w,IDC_EDIP6NRR,sbuffer,64); sscanf(sbuffer,"%f", &env[cworld].radius);break;
	     case IDC_EDIP6NSR: GetDlgItemText(w,IDC_EDIP6NSR,sbuffer,64); sscanf(sbuffer,"%f", &env[cworld].sradius);break;
	     case IDC_EDIP6FN:  GetDlgItemText(w,IDC_EDIP6FN,worldfiles,64);break;
	     case IDC_EDIP6WA1: env[cworld].obstacles[0][0] = (float) GetDlgItemInt(w,IDC_EDIP6WA1,NULL,0); break;
	     case IDC_EDIP6WA2: env[cworld].obstacles[0][1] = (float) GetDlgItemInt(w,IDC_EDIP6WA2,NULL,0); break;
	     case IDC_EDIP6WA3: env[cworld].obstacles[0][2] = (float) GetDlgItemInt(w,IDC_EDIP6WA3,NULL,0); break;
	     case IDC_EDIP6WA4: env[cworld].obstacles[0][3] = (float) GetDlgItemInt(w,IDC_EDIP6WA4,NULL,0); break;
	     case IDC_EDIP6WB1: env[cworld].obstacles[1][0] = (float) GetDlgItemInt(w,IDC_EDIP6WB1,NULL,0); break;
	     case IDC_EDIP6WB2: env[cworld].obstacles[1][1] = (float) GetDlgItemInt(w,IDC_EDIP6WB2,NULL,0); break;
	     case IDC_EDIP6WB3: env[cworld].obstacles[1][2] = (float) GetDlgItemInt(w,IDC_EDIP6WB3,NULL,0); break;
	     case IDC_EDIP6WB4: env[cworld].obstacles[1][3] = (float) GetDlgItemInt(w,IDC_EDIP6WB4,NULL,0); break;
	     case IDC_EDIP6WC1: env[cworld].obstacles[2][0] = (float) GetDlgItemInt(w,IDC_EDIP6WC1,NULL,0); break;
	     case IDC_EDIP6WC2: env[cworld].obstacles[2][1] = (float) GetDlgItemInt(w,IDC_EDIP6WC2,NULL,0); break;
	     case IDC_EDIP6WC3: env[cworld].obstacles[2][2] = (float) GetDlgItemInt(w,IDC_EDIP6WC3,NULL,0); break;
	     case IDC_EDIP6WC4: env[cworld].obstacles[2][3] = (float) GetDlgItemInt(w,IDC_EDIP6WC4,NULL,0); break;
	     case IDC_EDIP6WD1: env[cworld].obstacles[3][0] = (float) GetDlgItemInt(w,IDC_EDIP6WD1,NULL,0); break;
	     case IDC_EDIP6WD2: env[cworld].obstacles[3][1] = (float) GetDlgItemInt(w,IDC_EDIP6WD2,NULL,0); break;
	     case IDC_EDIP6WD3: env[cworld].obstacles[3][2] = (float) GetDlgItemInt(w,IDC_EDIP6WD3,NULL,0); break;
	     case IDC_EDIP6WD4: env[cworld].obstacles[3][3] = (float) GetDlgItemInt(w,IDC_EDIP6WD4,NULL,0); break;
	     case IDC_EDIP6WE1: env[cworld].obstacles[4][0] = (float) GetDlgItemInt(w,IDC_EDIP6WE1,NULL,0); break;
	     case IDC_EDIP6WE2: env[cworld].obstacles[4][1] = (float) GetDlgItemInt(w,IDC_EDIP6WE2,NULL,0); break;
	     case IDC_EDIP6WE3: env[cworld].obstacles[4][2] = (float) GetDlgItemInt(w,IDC_EDIP6WE3,NULL,0); break;
	     case IDC_EDIP6WE4: env[cworld].obstacles[4][3] = (float) GetDlgItemInt(w,IDC_EDIP6WE4,NULL,0); break;
	     case IDC_EDIP6WF1: env[cworld].obstacles[5][0] = (float) GetDlgItemInt(w,IDC_EDIP6WF1,NULL,0); break;
	     case IDC_EDIP6WF2: env[cworld].obstacles[5][1] = (float) GetDlgItemInt(w,IDC_EDIP6WF2,NULL,0); break;
	     case IDC_EDIP6WF3: env[cworld].obstacles[5][2] = (float) GetDlgItemInt(w,IDC_EDIP6WF3,NULL,0); break;
	     case IDC_EDIP6WF4: env[cworld].obstacles[5][3] = (float) GetDlgItemInt(w,IDC_EDIP6WF4,NULL,0); break;
	     case IDC_EDIP6WG1: env[cworld].obstacles[6][0] = (float) GetDlgItemInt(w,IDC_EDIP6WG1,NULL,0); break;
	     case IDC_EDIP6WG2: env[cworld].obstacles[6][1] = (float) GetDlgItemInt(w,IDC_EDIP6WG2,NULL,0); break;
	     case IDC_EDIP6WG3: env[cworld].obstacles[6][2] = (float) GetDlgItemInt(w,IDC_EDIP6WG3,NULL,0); break;
	     case IDC_EDIP6WG4: env[cworld].obstacles[6][3] = (float) GetDlgItemInt(w,IDC_EDIP6WG4,NULL,0); break;
	     case IDC_EDIP6WH1: env[cworld].obstacles[7][0] = (float) GetDlgItemInt(w,IDC_EDIP6WH1,NULL,0); break;
	     case IDC_EDIP6WH2: env[cworld].obstacles[7][1] = (float) GetDlgItemInt(w,IDC_EDIP6WH2,NULL,0); break;
	     case IDC_EDIP6WH3: env[cworld].obstacles[7][2] = (float) GetDlgItemInt(w,IDC_EDIP6WH3,NULL,0); break;
	     case IDC_EDIP6WH4: env[cworld].obstacles[7][3] = (float) GetDlgItemInt(w,IDC_EDIP6WH4,NULL,0); break;

	     case IDC_EDIP6RA1: env[cworld].roundobst[0][0] = (float) GetDlgItemInt(w,IDC_EDIP6RA1,NULL,0); break;
	     case IDC_EDIP6RA2: env[cworld].roundobst[0][1] = (float) GetDlgItemInt(w,IDC_EDIP6RA2,NULL,0); break;
	     case IDC_EDIP6RB1: env[cworld].roundobst[1][0] = (float) GetDlgItemInt(w,IDC_EDIP6RB1,NULL,0); break;
	     case IDC_EDIP6RB2: env[cworld].roundobst[1][1] = (float) GetDlgItemInt(w,IDC_EDIP6RB2,NULL,0); break;
	     case IDC_EDIP6RC1: env[cworld].roundobst[2][0] = (float) GetDlgItemInt(w,IDC_EDIP6RC1,NULL,0); break;
	     case IDC_EDIP6RC2: env[cworld].roundobst[2][1] = (float) GetDlgItemInt(w,IDC_EDIP6RC2,NULL,0); break;
	     case IDC_EDIP6RD1: env[cworld].roundobst[3][0] = (float) GetDlgItemInt(w,IDC_EDIP6RD1,NULL,0); break;
	     case IDC_EDIP6RD2: env[cworld].roundobst[3][1] = (float) GetDlgItemInt(w,IDC_EDIP6RD2,NULL,0); break;
	     case IDC_EDIP6RE1: env[cworld].roundobst[4][0] = (float) GetDlgItemInt(w,IDC_EDIP6RE1,NULL,0); break;
	     case IDC_EDIP6RE2: env[cworld].roundobst[4][1] = (float) GetDlgItemInt(w,IDC_EDIP6RE2,NULL,0); break;
	     case IDC_EDIP6RF1: env[cworld].roundobst[5][0] = (float) GetDlgItemInt(w,IDC_EDIP6RF1,NULL,0); break;
	     case IDC_EDIP6RF2: env[cworld].roundobst[5][1] = (float) GetDlgItemInt(w,IDC_EDIP6RF2,NULL,0); break;
	     case IDC_EDIP6RG1: env[cworld].roundobst[6][0] = (float) GetDlgItemInt(w,IDC_EDIP6RG1,NULL,0); break;
	     case IDC_EDIP6RG2: env[cworld].roundobst[6][1] = (float) GetDlgItemInt(w,IDC_EDIP6RG2,NULL,0); break;
	     case IDC_EDIP6RH1: env[cworld].roundobst[7][0] = (float) GetDlgItemInt(w,IDC_EDIP6RH1,NULL,0); break;
	     case IDC_EDIP6RH2: env[cworld].roundobst[7][1] = (float) GetDlgItemInt(w,IDC_EDIP6RH2,NULL,0); break;

	     case IDC_EDIP6SA1: env[cworld].sroundobst[0][0] = (float) GetDlgItemInt(w,IDC_EDIP6SA1,NULL,0); break;
	     case IDC_EDIP6SA2: env[cworld].sroundobst[0][1] = (float) GetDlgItemInt(w,IDC_EDIP6SA2,NULL,0); break;
	     case IDC_EDIP6SB1: env[cworld].sroundobst[1][0] = (float) GetDlgItemInt(w,IDC_EDIP6SB1,NULL,0); break;
	     case IDC_EDIP6SB2: env[cworld].sroundobst[1][1] = (float) GetDlgItemInt(w,IDC_EDIP6SB2,NULL,0); break;
	     case IDC_EDIP6SC1: env[cworld].sroundobst[2][0] = (float) GetDlgItemInt(w,IDC_EDIP6SC1,NULL,0); break;
	     case IDC_EDIP6SC2: env[cworld].sroundobst[2][1] = (float) GetDlgItemInt(w,IDC_EDIP6SC2,NULL,0); break;
	     case IDC_EDIP6SD1: env[cworld].sroundobst[3][0] = (float) GetDlgItemInt(w,IDC_EDIP6SD1,NULL,0); break;
	     case IDC_EDIP6SD2: env[cworld].sroundobst[3][1] = (float) GetDlgItemInt(w,IDC_EDIP6SD2,NULL,0); break;
	     case IDC_EDIP6SE1: env[cworld].sroundobst[4][0] = (float) GetDlgItemInt(w,IDC_EDIP6SE1,NULL,0); break;
	     case IDC_EDIP6SE2: env[cworld].sroundobst[4][1] = (float) GetDlgItemInt(w,IDC_EDIP6SE2,NULL,0); break;
	     case IDC_EDIP6SF1: env[cworld].sroundobst[5][0] = (float) GetDlgItemInt(w,IDC_EDIP6SF1,NULL,0); break;
	     case IDC_EDIP6SF2: env[cworld].sroundobst[5][1] = (float) GetDlgItemInt(w,IDC_EDIP6SF2,NULL,0); break;
	     case IDC_EDIP6SG1: env[cworld].sroundobst[6][0] = (float) GetDlgItemInt(w,IDC_EDIP6SG1,NULL,0); break;
	     case IDC_EDIP6SG2: env[cworld].sroundobst[6][1] = (float) GetDlgItemInt(w,IDC_EDIP6SG2,NULL,0); break;
	     case IDC_EDIP6SH1: env[cworld].sroundobst[7][0] = (float) GetDlgItemInt(w,IDC_EDIP6SH1,NULL,0); break;
	     case IDC_EDIP6SH2: env[cworld].sroundobst[7][1] = (float) GetDlgItemInt(w,IDC_EDIP6SH2,NULL,0); break;

	     case IDC_EDIP6TA1: env[cworld].foodzones[0][0] = (float) GetDlgItemInt(w,IDC_EDIP6TA1,NULL,0); break;
	     case IDC_EDIP6TA2: env[cworld].foodzones[0][1] = (float) GetDlgItemInt(w,IDC_EDIP6TA2,NULL,0); break;
	     case IDC_EDIP6TA3: env[cworld].foodzones[0][2] = (float) GetDlgItemInt(w,IDC_EDIP6TA3,NULL,0); break;
	     case IDC_EDIP6TB1: env[cworld].foodzones[1][0] = (float) GetDlgItemInt(w,IDC_EDIP6TB1,NULL,0); break;
	     case IDC_EDIP6TB2: env[cworld].foodzones[1][1] = (float) GetDlgItemInt(w,IDC_EDIP6TB2,NULL,0); break;
	     case IDC_EDIP6TB3: env[cworld].foodzones[1][2] = (float) GetDlgItemInt(w,IDC_EDIP6TB3,NULL,0); break;
	     case IDC_EDIP6TC1: env[cworld].foodzones[2][0] = (float) GetDlgItemInt(w,IDC_EDIP6TC1,NULL,0); break;
	     case IDC_EDIP6TC2: env[cworld].foodzones[2][1] = (float) GetDlgItemInt(w,IDC_EDIP6TC2,NULL,0); break;
	     case IDC_EDIP6TC3: env[cworld].foodzones[2][2] = (float) GetDlgItemInt(w,IDC_EDIP6TC3,NULL,0); break;
	     case IDC_EDIP6TD1: env[cworld].foodzones[3][0] = (float) GetDlgItemInt(w,IDC_EDIP6TD1,NULL,0); break;
	     case IDC_EDIP6TD2: env[cworld].foodzones[3][1] = (float) GetDlgItemInt(w,IDC_EDIP6TD2,NULL,0); break;
	     case IDC_EDIP6TD3: env[cworld].foodzones[3][2] = (float) GetDlgItemInt(w,IDC_EDIP6TD3,NULL,0); break;


	     case IDC_EDIP6LA1: env[cworld].bulblights[0][0] = (float) GetDlgItemInt(w,IDC_EDIP6LA1,NULL,0); break;
	     case IDC_EDIP6LA2: env[cworld].bulblights[0][1] = (float) GetDlgItemInt(w,IDC_EDIP6LA2,NULL,0); break;
	     case IDC_EDIP6LB1: env[cworld].bulblights[1][0] = (float) GetDlgItemInt(w,IDC_EDIP6LB1,NULL,0); break;
	     case IDC_EDIP6LB2: env[cworld].bulblights[1][1] = (float) GetDlgItemInt(w,IDC_EDIP6LB2,NULL,0); break;
	     case IDC_EDIP6LC1: env[cworld].bulblights[2][0] = (float) GetDlgItemInt(w,IDC_EDIP6LC1,NULL,0); break;
	     case IDC_EDIP6LC2: env[cworld].bulblights[2][1] = (float) GetDlgItemInt(w,IDC_EDIP6LC2,NULL,0); break;
	     case IDC_EDIP6LD1: env[cworld].bulblights[3][0] = (float) GetDlgItemInt(w,IDC_EDIP6LD1,NULL,0); break;
	     case IDC_EDIP6LD2: env[cworld].bulblights[3][1] = (float) GetDlgItemInt(w,IDC_EDIP6LD2,NULL,0); break;


	     case IDC_EDIP6PA1: env[cworld].starts[0][0] = (float) GetDlgItemInt(w,IDC_EDIP6PA1,NULL,0); break;
	     case IDC_EDIP6PA2: env[cworld].starts[0][1] = (float) GetDlgItemInt(w,IDC_EDIP6PA2,NULL,0); break;
	     case IDC_EDIP6PA3: env[cworld].starts[0][2] = (float) GetDlgItemInt(w,IDC_EDIP6PA3,NULL,0); break;
	     case IDC_EDIP6PB1: env[cworld].starts[1][0] = (float) GetDlgItemInt(w,IDC_EDIP6PB1,NULL,0); break;
	     case IDC_EDIP6PB2: env[cworld].starts[1][1] = (float) GetDlgItemInt(w,IDC_EDIP6PB2,NULL,0); break;
	     case IDC_EDIP6PB3: env[cworld].starts[1][2] = (float) GetDlgItemInt(w,IDC_EDIP6PB3,NULL,0); break;
	     case IDC_EDIP6PC1: env[cworld].starts[2][0] = (float) GetDlgItemInt(w,IDC_EDIP6PC1,NULL,0); break;
	     case IDC_EDIP6PC2: env[cworld].starts[2][1] = (float) GetDlgItemInt(w,IDC_EDIP6PC2,NULL,0); break;
	     case IDC_EDIP6PC3: env[cworld].starts[2][2] = (float) GetDlgItemInt(w,IDC_EDIP6PC3,NULL,0); break;
	     case IDC_EDIP6PD1: env[cworld].starts[3][0] = (float) GetDlgItemInt(w,IDC_EDIP6PD1,NULL,0); break;
	     case IDC_EDIP6PD2: env[cworld].starts[3][1] = (float) GetDlgItemInt(w,IDC_EDIP6PD2,NULL,0); break;
	     case IDC_EDIP6PD3: env[cworld].starts[3][2] = (float) GetDlgItemInt(w,IDC_EDIP6PD3,NULL,0); break;
	     case IDC_EDIP6PE1: env[cworld].starts[4][0] = (float) GetDlgItemInt(w,IDC_EDIP6PE1,NULL,0); break;
	     case IDC_EDIP6PE2: env[cworld].starts[4][1] = (float) GetDlgItemInt(w,IDC_EDIP6PE2,NULL,0); break;
	     case IDC_EDIP6PE3: env[cworld].starts[4][2] = (float) GetDlgItemInt(w,IDC_EDIP6PE3,NULL,0); break;
	     case IDC_EDIP6PF1: env[cworld].starts[5][0] = (float) GetDlgItemInt(w,IDC_EDIP6PF1,NULL,0); break;
	     case IDC_EDIP6PF2: env[cworld].starts[5][1] = (float) GetDlgItemInt(w,IDC_EDIP6PF2,NULL,0); break;
	     case IDC_EDIP6PF3: env[cworld].starts[5][2] = (float) GetDlgItemInt(w,IDC_EDIP6PF3,NULL,0); break;
	     case IDC_EDIP6PG1: env[cworld].starts[6][0] = (float) GetDlgItemInt(w,IDC_EDIP6PG1,NULL,0); break;
	     case IDC_EDIP6PG2: env[cworld].starts[6][1] = (float) GetDlgItemInt(w,IDC_EDIP6PG2,NULL,0); break;
	     case IDC_EDIP6PG3: env[cworld].starts[6][2] = (float) GetDlgItemInt(w,IDC_EDIP6PG3,NULL,0); break;
	     case IDC_EDIP6PH1: env[cworld].starts[7][0] = (float) GetDlgItemInt(w,IDC_EDIP6PH1,NULL,0); break;
	     case IDC_EDIP6PH2: env[cworld].starts[7][1] = (float) GetDlgItemInt(w,IDC_EDIP6PH2,NULL,0); break;
	     case IDC_EDIP6PH3: env[cworld].starts[7][2] = (float) GetDlgItemInt(w,IDC_EDIP6PH3,NULL,0); break;
           }
	   
    }	 
 }

return FALSE;
}



/*
 * handles dialog box Parameters->General
 */
BOOL CALLBACK boxprocss(HWND w,UINT m,WPARAM p1,LPARAM p2)
{


switch(m)
 {
 case WM_INITDIALOG:
            drawsampleob = 0;
	    break;
 case WM_COMMAND:
    switch(HIWORD(p1))
     { 
        case BN_CLICKED:
	  switch (LOWORD(p1))
	   {
	     case IDOK:
		  EndDialog(w,0);
		  break;
	     case IDC_RSS1:
	         drawsampleob = 1;
	         CheckDlgButton(w,IDC_RSS1,1);
	         CheckDlgButton(w,IDC_RSS2,0);
	         CheckDlgButton(w,IDC_RSS3,0);
	         CheckDlgButton(w,IDC_RSS4,0);
                 break;
	     case IDC_RSS2:
	         drawsampleob = 2;
	         CheckDlgButton(w,IDC_RSS1,0);
	         CheckDlgButton(w,IDC_RSS2,1);
	         CheckDlgButton(w,IDC_RSS3,0);
	         CheckDlgButton(w,IDC_RSS4,0);                 
		 break;
	     case IDC_RSS3:
	         drawsampleob = 3;
	         CheckDlgButton(w,IDC_RSS1,0);
	         CheckDlgButton(w,IDC_RSS2,0);
	         CheckDlgButton(w,IDC_RSS3,1);
	         CheckDlgButton(w,IDC_RSS4,0);                 
		 break;
	     case IDC_RSS4:
	         drawsampleob = 4;
	         CheckDlgButton(w,IDC_RSS1,0);
	         CheckDlgButton(w,IDC_RSS2,0);
	         CheckDlgButton(w,IDC_RSS3,0);
	         CheckDlgButton(w,IDC_RSS4,1);                 
		 break;
           }
	break;
        case EN_CHANGE:
	  switch (LOWORD(p1))
	   {	 
	     //case IDC_EDIGNP: npopulations =GetDlgItemInt(w,IDC_EDIGNP,NULL,0);break;
           }
	break;
    }	 
 }

return FALSE;
}


/*
 * handle the dialog box Run->Sample_Object
 */
BOOL CALLBACK boxprocsa(HWND w,UINT m,WPARAM p1,LPARAM p2)
{

switch(m)
 {
 case WM_INITDIALOG:
            SetDlgItemInt(w,IDC_EDSANT,samplenturns,0);
            SetDlgItemInt(w,IDC_EDSACT,sampleturn,0);
            SetDlgItemInt(w,IDC_EDSAID,sampleinitdist,0);
            SetDlgItemInt(w,IDC_EDSAIN,sampleinterdist,0);
            SetDlgItemInt(w,IDC_EDSATA,timeadjust,0);
           if (sampleob == 1)
	       CheckDlgButton(w,IDC_RSA1,1);
	      else
	       CheckDlgButton(w,IDC_RSA1,0);
           if (sampleob == 2)
	       CheckDlgButton(w,IDC_RSA2,1);
	      else
	       CheckDlgButton(w,IDC_RSA2,0);           
	   if (sampleob == 3)
	       CheckDlgButton(w,IDC_RSA3,1);
	      else
	       CheckDlgButton(w,IDC_RSA3,0);           
	   if (sampleob == 4)
	       CheckDlgButton(w,IDC_RSA4,1);
	      else
	       CheckDlgButton(w,IDC_RSA4,0);
	    break;
 case WM_COMMAND:
    switch(HIWORD(p1))
     { 
        case BN_CLICKED:
	  switch (LOWORD(p1))
	   {
	     case IDSAEND:
		  sampleob = 0;
		  EndDialog(w,0);
		  break;
	     case IDSAGO:
		  EndDialog(w,0);
		  break;
	     case IDSASAVE:
                  samplesave = 1;
		  EndDialog(w,0);
		  break;
	     case IDC_RSA1:
	         sampleob = 1;
	         CheckDlgButton(w,IDC_RSA1,1);
	         CheckDlgButton(w,IDC_RSA2,0);
	         CheckDlgButton(w,IDC_RSA3,0);
	         CheckDlgButton(w,IDC_RSA4,0);
                 break;
	     case IDC_RSA2:
	         sampleob = 2;
	         CheckDlgButton(w,IDC_RSA1,0);
	         CheckDlgButton(w,IDC_RSA2,1);
	         CheckDlgButton(w,IDC_RSA3,0);
	         CheckDlgButton(w,IDC_RSA4,0);                 
		 break;
	     case IDC_RSA3:
	         sampleob = 3;
	         CheckDlgButton(w,IDC_RSA1,0);
	         CheckDlgButton(w,IDC_RSA2,0);
	         CheckDlgButton(w,IDC_RSA3,1);
	         CheckDlgButton(w,IDC_RSA4,0);                 
		 break;
	     case IDC_RSA4:
	         sampleob = 4;
	         CheckDlgButton(w,IDC_RSA1,0);
	         CheckDlgButton(w,IDC_RSA2,0);
	         CheckDlgButton(w,IDC_RSA3,0);
	         CheckDlgButton(w,IDC_RSA4,1);                 
		 break;
           }
	break;
	    
        case EN_CHANGE:
	  switch (LOWORD(p1))
	   {	  
	    case IDC_EDSANT: samplenturns     = GetDlgItemInt(w,IDC_EDSANT,NULL,0);break;
	    case IDC_EDSACT: sampleturn       = GetDlgItemInt(w,IDC_EDSACT,NULL,0);break;
	    case IDC_EDSAID: sampleinitdist   = GetDlgItemInt(w,IDC_EDSAID,NULL,0);break;
	    case IDC_EDSAIN: sampleinterdist  = GetDlgItemInt(w,IDC_EDSAIN,NULL,0);break;
	    case IDC_EDSATA: timeadjust       = GetDlgItemInt(w,IDC_EDSATA,NULL,0);break;
           }
	break;
    }	 
 }

return FALSE;
}


/*
 * handle dialog box hlp
 */
BOOL CALLBACK boxprochlp(HWND w,UINT m,WPARAM p1,LPARAM p2)
{


switch(m)
 {
 case WM_INITDIALOG:
	    break;
 case WM_COMMAND:
    switch(HIWORD(p1))
     { 
        case BN_CLICKED:
	  switch (LOWORD(p1))
	   {
	     case IDOK:
		  EndDialog(w,0);
		  break;
           }
	break;
    }	 
 }

return FALSE;
}


/*
 * creates a secondary window with a separate thread
 */
void
creawin()
{
    hdc=NULL;
    hThread= CreateThread(NULL,0,(LPTHREAD_START_ROUTINE) finestra, &dwThrdParam,0,&dwThreadId);                 
    while(hdc == NULL);
}

/*
 * close a secondary window
 */
void
chiudewin()
{
	PostMessage(hwnd,WM_DESTROY,0,0);
}





/*
 * secondary window with a separate thread
 */
DWORD finestra(LPDWORD p)
{
    long err;

    hinst=GetModuleHandle(NULL);

    //   wc.style		=CS_BYTEALIGNCLIENT|CS_SAVEBITS|CS_HREDRAW|CS_VREDRAW|CS_OWNDC; 
    wc.style		=CS_SAVEBITS|CS_OWNDC; 
    wc.lpfnWndProc	=(WNDPROC)WindowProc; 
    wc.cbClsExtra	=0; 
    wc.cbWndExtra	=0; 
    wc.hInstance	=hinst; 
    wc.hIcon		=NULL; 
    wc.hCursor		=LoadCursor(NULL,IDC_ARROW); 
    wc.hbrBackground=(HBRUSH)(COLOR_WINDOW+1); 
    wc.lpszMenuName	=NULL; 
    wc.lpszClassName=APPNAME; 

    err=RegisterClass(&wc);

    hwnd=CreateWindow(
		APPNAME,
		APPNAME,
		WS_TILEDWINDOW|WS_VISIBLE,
		CW_USEDEFAULT,
		0,
		wdx,
		wdy,
		NULL,
		NULL,
		hinst,
		NULL);


    ShowWindow(hwnd,SW_SHOWNORMAL);

    SetForegroundWindow(hwnd);
    hdc=GetDC(hwnd);
    createw2 = 1;

    while(GetMessage(&msg,NULL,0,0)) DispatchMessage(&msg);
    return 0;

}





/*
 * routine di gestione of the secondary window
 */

LRESULT CALLBACK WindowProc(HWND w,UINT m,WPARAM p1,LPARAM p2)
{ 

  switch (m)  
      {
        case WM_DESTROY: 
	       createw2 = 0;
	       PostQuitMessage(0);
	       fs=0;
               break;
	case WM_RBUTTONDOWN:
	       userbreak = 1;
	       break;
	case WM_USER :
	       break;
	case WM_SHOWWINDOW:
	       break;
	case WM_PAINT:
	       BeginPaint(hwnd,&ps);
	       //riplotta();
  	       EndPaint(hwnd,&ps);
	       return (DefWindowProc(w,m,p1,p2));
	       break;
	default: return (DefWindowProc(w,m,p1,p2));
	       break;
      }
    return (DefWindowProc(w,m,p1,p2));
}



/*
 * display an error message in a box and exit (graphic)
 */
void 
display_error(char *emessage)

{

   MessageBox(hwndm, emessage, "Error", MB_OK); 
   exit(-1);

}

/*
 * display a warinig message in a box (graphic)
 */
void 
display_warning(char *emessage)

{

   MessageBox(hwndm, emessage, "Warning", MB_OK); 

}

/*
 * display a double (to use for debugging)
 */
void 
display_double(double val)

{

   char sbuffer[64];

   sprintf(sbuffer,"value: %f",val);
   MessageBox(hwndm, sbuffer, "Display Double", MB_OK); 

}

/*
 * append the first n element of savedata[] 
 * use d decimals 
 */
void save_data(char *filen, int n, int d)
{

  FILE *fopen();
  FILE *fp;
  extern double savedata[];
  int  i;

  if (n > 50)
   {
     display_warning("we can save a maximun of 50 data");
     n = 50;
   }

  fp = fopen(filen,"a");
  for (i=0; i < n; i++)
   {
    if (d == 0) fprintf(fp,"%.0f ",savedata[i]);
    if (d == 1) fprintf(fp,"%.1f ",savedata[i]);
    if (d == 2) fprintf(fp,"%.2f ",savedata[i]);
    if (d == 3) fprintf(fp,"%.3f ",savedata[i]);
    if (d > 3) fprintf(fp,"%f ",savedata[i]);
   }
  fprintf(fp,"\n");
  fclose(fp);

}


